.\" Traduccin realizada por Adrin Prez Jorge (alu1415@csi.ull.es)
.\" y finalizada el mircoles, 17 de febrero de 1999.
.\" Traduccin revisada el viernes, 9 de abril de 1999 por
.\" 	Adrin Prez Jorge (alu1415@csi.ull.es)
.\"
.TH FLEX 1 "Abril 1995" "Versin 2.5"
.SH NOMBRE
flex \- generador de analizadores lxicos rpidos
.SH SINOPSIS
.B flex
.B [\-bcdfhilnpstvwBFILTV78+? \-C[aefFmr] \-osalida \-Pprefijo \-Sesqueleto]
.B [\-\-help \-\-version]
.I [nombrefichero ...]
.SH INTRODUCCIN
Este manual describe
.I flex,
una herramienta para la generacin de programas que realizan
concordancia de patrones en texto.  El manual incluye a la vez
secciones de tutorial y de referencia:
.nf

    Descripcin
        una breve introduccin a la herramienta

    Algunos Ejemplos Simples

    Formato del Fichero de Entrada

    Patrones
        las expresiones regulares extendidas que utiliza flex

    Cmo se Empareja la Entrada
        las reglas para determinar lo que ha concordado

    Acciones
        cmo especificar qu hacer cuando concuerde un patrn

    El Escner Generado
        detalles respecto al escner que produce flex;
        cmo controlar la fuente de entrada

    Condiciones de Arranque
        la introducin de contexto en sus escneres, y
        conseguir "mini-escneres"

    Mltiples Buffers de Entrada
        cmo manipular varias fuentes de entrada; cmo
        analizar cadenas en lugar de ficheros.

    Reglas de Fin-de-Fichero
        reglas especiales para reconocer el final de la entrada

    Macros Miscelneas
        un sumario de macros disponibles para las acciones

    Valores Disponibles para el Usuario
        un sumario de valores disponibles para las acciones

    Interfaz con Yacc
        conectando escneres de flex junto con analizadores de yacc

    Opciones
        opciones de lnea de comando de flex, y la directiva
        "%option"

    Consideraciones de Rendimiento
        cmo hacer que sus analizadores vayan tan rpido
        como sea posible

    Generando Escneres en C++
        la facilidad (experimental) para generar analizadores
        lxicos como clases de C++

    Incompatibilidades con Lex y POSIX
        cmo flex difiere del lex de AT&T y del lex estndar
        de POSIX 

    Diagnsticos
        esos mensajes de error producidos por flex (o por
        los escneres que este genera) cuyo significado podra
        no ser evidente

    Ficheros
        los ficheros usados por flex

    Deficiencias / Errores
        problemas de flex conocidos

    Ver Tambin
        otra documentacin, herramientas relacionadas

    Autor
        incluye informacin de contacto

.fi
.SH DESCRIPCIN
.I flex
es una herramienta para generar
.I escneres:
programas que reconocen patrones lxicos en un texto.
.I flex
lee los ficheros de entrada dados, o la entrada estndar si no se le
ha indicado ningn nombre de fichero, con la descripcin de un escner
a generar.  La descripcin se encuentra en forma de parejas de
expresiones regulares y cdigo C, denominadas
.I reglas.  flex
genera como salida un fichero fuente en C,
.B lex.yy.c,
que define una rutina
.B yylex().
Este fichero se compila y se enlaza con la librera
.B \-lfl
para producir un ejecutable.  Cuando se arranca el fichero ejecutable,
este analiza su entrada en busca de casos de las expresiones
regulares.  Siempre que encuentra uno, ejecuta el cdigo C
correspondiente.
.SH ALGUNOS EJEMPLOS SIMPLES
.PP
En primer lugar veremos algunos ejemplos simples para una toma de
contacto con el uso de
.I flex.
La siguiente entrada de 
.I flex
especifica un escner que siempre que encuentre la cadena "username"
la reemplazar por el nombre de entrada al sistema del usuario:
.nf

    %%
    username    printf( "%s", getlogin() );

.fi
Por defecto, cualquier texto que no reconozca el analizador lxico de
.I flex
se copia a la salida, as que el efecto neto de este escner es copiar
su fichero de entrada a la salida con cada aparicin de "username"
expandida.
En esta entrada, hay solamente una regla.  "username" es el
.I patrn
y el "printf" es la
.I accin.
El "%%" marca el comienzo de las reglas.
.PP
Aqu hay otro ejemplo simple:
.nf

            int num_lineas = 0, num_caracteres = 0;

    %%
    \\n      ++num_lineas; ++num_caracteres;
    .       ++num_caracteres;

    %%
    main()
            {
            yylex();
            printf( "# de lneas = %d, # de caracteres. = %d\\n",
                    num_lineas, num_caracteres );
            }

.fi
Este analizador cuenta el nmero de caracteres y el nmero de lneas
en su entrada (no produce otra salida que el informe final de la
cuenta).  La primera lnea declara dos variables globales,
"num_lineas" y "num_caracteres", que son visibles al mismo tiempo
dentro de 
.B yylex()
y en la rutina
.B main()
declarada despus del segundo "%%".  Hay dos reglas, una que
empareja una lnea nueva ("\\n") e incrementa la cuenta de lneas y la
cuenta de caracteres, y la que empareja cualquier caracter que no sea
una lnea nueva (indicado por la expresin regular ".").
.PP
Un ejemplo algo ms complicado:
.nf

    /* escner para un lenguaje de juguete al estilo de Pascal */

    %{
    /* se necesita esto para la llamada a atof() ms abajo */
    #include <math.h>
    %}

    DIGITO   [0-9]
    ID       [a-z][a-z0-9]*

    %%

    {DIGITO}+   {
                printf( "Un entero: %s (%d)\\n", yytext,
                        atoi( yytext ) );
                }

    {DIGITO}+"."{DIGITO}*      {
                printf( "Un real: %s (%g)\\n", yytext,
                        atof( yytext ) );
                }

    if|then|begin|end|procedure|function        {
                printf( "Una palabra clave: %s\\n", yytext );
                }

    {ID}        printf( "Un identificador: %s\\n", yytext );

    "+"|"-"|"*"|"/"   printf( "Un operador: %s\\n", yytext );

    "{"[^}\\n]*"}"     /* se come una linea de comentarios */

    [ \\t\\n]+          /* se come los espacios en blanco */

    .           printf( "Caracter no reconocido: %s\\n", yytext );

    %%

    main( argc, argv )
    int argc;
    char **argv;
        {
        ++argv, --argc;  /* se salta el nombre del programa */
        if ( argc > 0 )
                yyin = fopen( argv[0], "r" );
        else
                yyin = stdin;
        
        yylex();
        }

.fi
Esto podra ser los comienzos de un escner simple para un lenguaje
como Pascal.  Este identifica diferentes tipos de
.I tokens
e informa a cerca de lo que ha visto.
.PP
Los detalles de este ejemplo se explicarn en las secciones
siguientes.
.SH FORMATO DEL FICHERO DE ENTRADA
El fichero de entrada de
.I flex
est compuesto de tres secciones, separadas por una lnea donde
aparece nicamente un
.B %%
en esta:
.nf

    definiciones
    %%
    reglas
    %%
    cdigo de usuario

.fi
La seccin de
.I definiciones
contiene declaraciones de definiciones de
.I nombres
sencillas para simplificar la especificacin del escner,
y declaraciones de 
.I condiciones de arranque,
que se explicarn en una seccin posterior.
.PP
Las definiciones de nombre tienen la forma:
.nf

    nombre definicin

.fi
El "nombre" es una palabra que comienza con una letra o un subrayado
('_') seguido por cero o ms letras, dgitos, '_', o '-' (guin).
La definicin se considera que comienza en el primer caracter que no
sea un espacio en blanco siguiendo al nombre y continuando hasta el
final de la lnea.
Posteriormente se puede hacer referencia a la definicin utilizando
"{nombre}", que se expandir a "(definicin)".  Por ejemplo,
.nf

    DIGITO   [0-9]
    ID       [a-z][a-z0-9]*

.fi
define "DIGITO" como una expresin regular que empareja un dgito
sencillo, e "ID" como una expresin regular que empareja una letra
seguida por cero o ms letras o dgitos.
Una referencia posterior a
.nf

    {DIGITO}+"."{DIGITO}*

.fi
es idntica a
.nf

    ([0-9])+"."([0-9])*

.fi
y empareja uno o ms dgitos seguido por un '.' seguido por cero o ms
dgitos.
.PP
La seccin de
.I reglas
en la entrada de
.I flex
contiene una serie de reglas de la forma:
.nf

    patrn   accin

.fi
donde el patrn debe estar sin sangrar y la accin debe comenzar en la
misma lnea.
.PP
Ver ms abajo para una descripcin ms amplia sobre patrones y
acciones.
.PP
Finalmente, la seccin de cdigo de usuario simplemente se copia a
.B lex.yy.c
literalmente.
Esta seccin se utiliza para rutinas de complemento que llaman al
escner o son llamadas por este.  La presencia de esta seccin es
opcional; Si se omite, el segundo
.B %%
en el fichero de entrada se podra omitir tambin.
.PP
En las secciones de definiciones y reglas, cualquier texto
.I sangrado
o encerrado entre
.B %{
y
.B %}
se copia ntegramente a la salida (sin los %{}'s).
Los %{}'s deben aparecer sin sangrar en lneas ocupadas nicamente por
estos.
.PP
En la seccin de reglas,
cualquier texto o %{} sangrado que aparezca antes de la primera regla
podra utilizarse para declarar variables que son locales a la rutina
de anlisis y (despus de las declaraciones)
al cdigo que debe ejecutarse siempre que se entra a la rutina de
anlisis.
Cualquier otro texto sangrado o %{} en la seccin de reglas sigue
copindose a la salida, pero su significado no est bien definido y
bien podra causar errores en tiempo de compilacin (esta propiedad se
presenta para conformidad con
.I POSIX 
; ver ms abajo para otras caractersticas similares)
.PP
En la seccin de definiciones (pero no en la seccin de reglas),
un comentario sin sangra (es decir, una lnea comenzando con "/*")
tambin se copia literalmente a la salida hasta el prximo "*/".
.SH PATRONES
Los patrones en la entrada se escriben utilizando un conjunto extendido
de expresiones regulares.  Estas son:
.nf

    x          empareja el caracter 'x'
    .          cualquier caracter (byte) excepto una lnea nueva
    [xyz]      una "clase de caracteres"; en este caso, el patrn
                 empareja una 'x', una 'y', o una 'z'
    [abj-oZ]   una "clase de caracteres" con un rango; empareja
                 una 'a', una 'b', cualquier letra desde la 'j'
                 hasta la 'o', o una 'Z'
    [^A-Z]     una "clase de caracteres negada", es decir, cualquier
                 caracter menos los que aparecen en la clase.  En 
                 este caso, cualquier caracter EXCEPTO una letra
                 mayscula.
    [^A-Z\\n]   cualquier caracter EXCEPTO una letra mayscula o
                 una lnea nueva
    r*         cero o ms r's, donde r es cualquier expresin regular
    r+         una o ms r's
    r?         cero o una r (es decir, "una r opcional")
    r{2,5}     donde sea de dos a cinco r's
    r{2,}      dos o ms r's
    r{4}       exactamente 4 r's
    {nombre}   la expansin de la definicin de "nombre"
               (ver ms abajo)
    "[xyz]\\"foo"
               la cadena literal: [xyz]"foo
    \\X         si X es una 'a', 'b', 'f', 'n', 'r', 't', o 'v',
                 entonces la interpretacin ANSI-C de \\x.
                 En otro caso, un literal 'X' (usado para
                 indicar operadores tales como '*')
    \\0         un caracter NUL (cdigo ASCII 0)
    \\123       el caracter con valor octal 123
    \\x2a       el caracter con valor hexadecimal 2a
    (r)        empareja una r; los parntesis se utilizan para
                 anular la precedencia (ver ms abajo)


    rs         la expresin regular r seguida por la expresin
                 regular s; se denomina "concatenacin"


    r|s        bien una r o una s


    r/s        una r pero slo si va seguida por una s.  El
                 texto emparejado por s se incluye cuando se
                 determina si esta regla es el "emparejamiento
                 ms largo", pero se devuelve entonces a la
                 entrada antes que se ejecute la accin.  As
                 que la accin slo ve el texto emparejado
                 por r.  Este tipo de patrones se llama
                 "de contexto posterior".
                 (Hay algunas combinaciones de r/s que flex
                 no puede emparejar correctamente; vea las notas
                 en la seccin Deficiencias / Errores ms abajo
                 respecto al "contexto posterior peligroso".)
    ^r         una r, pero slo al comienzo de una lnea (es
                 decir, justo al comienzo del anlisis, o a la
                 derecha despus de que se haya analizado una
                 lnea nueva).
    r$         una r, pero slo al final de una lnea (es decir,
                 justo antes de una lnea nueva).  Equivalente
                 a "r/\\n".

               Fjese que la nocin de flex de una "lnea nueva"
               es exctamente lo que el compilador de C utilizado
               para compilar flex interprete como '\\n'; en
               particular, en algunos sistemas DOS debe filtrar
               los \\r's de la entrada used mismo, o explcitamente
               usar r/\\r\\n para "r$".


    <s>r       una r, pero slo en la condicin de arranque s
                 (ver ms abajo para una discusin sobre las
                 condiciones de arranque)
    <s1,s2,s3>r
               lo mismo, pero en cualquiera de las condiciones
                 de arranque s1, s2, o s3
    <*>r       una r en cualquier condicin de arranque, incluso
                 una exclusiva.


    <<EOF>>    un fin-de-fichero
    <s1,s2><<EOF>>
               un fin-de-fichero en una condicin de arranque s1 o s2

.fi
Fjese que dentro de una clase de caracteres, todos los operadores de
expresiones regulares pierden su significado especial excepto el
caracter de escape ('\\') y los operadores de clase de caracteres, '-',
']', y, al principio de la clase, '^'.
.PP
Las expresiones regulares en el listado anterior estn agrupadas de
acuerdo a la precedencia, desde la precedencia ms alta en la cabeza a
la ms baja al final.
Aquellas agrupadas conjuntamente tienen la misma precedencia.  Por
ejemplo,
.nf

    foo|bar*

.fi
es lo mismo que
.nf

    (foo)|(ba(r*))

.fi
ya que el operador '*' tiene mayor precedencia que la concatenacin, y
la concatenacin ms alta que el operador '|'.  Este patrn por
lo tanto empareja
.I bien
la cadena "foo"
.I o
la cadena "ba" seguida de cero o ms r's.
Para emparejar "foo" o, cero o ms "bar"'s, use:
.nf

    foo|(bar)*

.fi
y para emparejar cero o ms "foo"'s o "bar"'s:
.nf

    (foo|bar)*

.fi
.PP
Adems de caracteres y rangos de caracteres, las clases de caracteres
pueden tambin contener
.I expresiones
de clases de caracteres.
Son expresiones encerradas entre los delimitadores
.B [:
y
.B :]
(que tambin deben aparecer entre el '[' y el ']' de la clase de
caracteres; adems pueden darse otros elementos dentro de la clase de
caracteres).
Las expresiones vlidas son:
.nf

    [:alnum:] [:alpha:] [:blank:]
    [:cntrl:] [:digit:] [:graph:]
    [:lower:] [:print:] [:punct:]
    [:space:] [:upper:] [:xdigit:]

.fi
Todas estas expresiones designan un conjunto de caracteres
equivalentes a la correspondiente funcin estndar
.B isXXX
de C.  Por ejemplo,
.B [:alnum:]
designa aquellos caracteres para los cuales
.B isalnum()
devuelve verdadero - esto es, cualquier caracter alfabtico o numrico.
Algunos sistemas no ofrecen
.B isblank(),
as que flex define
.B [:blank:]
como un espacio en blanco o un tabulador.
.PP
Por ejemplo, las siguientes clases de caracteres son todas equivalentes:
.nf

    [[:alnum:]]
    [[:alpha:][:digit:]]
    [[:alpha:]0-9]
    [a-zA-Z0-9]

.fi
Si su escner ignora la distincin entre maysculas y minsculas (la bandera
.B \-i
), entonces
.B [:upper:]
y
.B [:lower:]
son equivalentes a
.B [:alpha:].
.PP
Algunas notas sobre los patrones:
.IP -
Una clase de caracteres negada tal como el ejemplo "[^A-Z]" anterior
.I emparejar una lnea nueva
a menos que "\\n" (o una secuencia de escape equivalente) sea uno de
los caracteres presentes explcitamente en la clase de caracteres
negada (p.ej., "[^A-Z\\n]").  Esto es diferente a cmo muchas de
las otras herramientas de expresiones regulares tratan las clases de
caracteres negadas, pero desafortunadamente la inconsistencia est
fervientemente enrraizada histricamente.
Emparejar lneas nuevas significa que un patrn como [^"]* puede
emparejar la entrada completa a menos que haya otra comilla en la
entrada.
.IP -
Una regla puede tener lo ms una instancia del contexto posterior (el
operador '/' o el operador '$').  La condicin de arranque, los
patrones '^', y "<<EOF>>" pueden aparecer solamente al principio de un
patrn, y, al igual que con '/' y '$', no pueden agruparse dentro de
parntesis.  Un '^' que no aparezca al principio de una regla o un '$'
que no aparezca al final de una regla pierde sus propiedades especiales y
es tratado como un caracter normal.
.IP
Lo siguiente no est permitido:
.nf

    foo/bar$
    <sc1>foo<sc2>bar

.fi
Fjese que la primera regla se puede escribir como "foo/bar\\n".
.IP
En el siguiente ejemplo un '$' o un '^' es tratado como un caracter
normal:
.nf

    foo|(bar$)
    foo|^bar

.fi
Si lo que se desea es un "foo" o un "bar" seguido de una lnea nueva,
puede usarse lo siguiente (la accin especial '|' se explica ms
abajo):
.nf

    foo      |
    bar$     /* la accin va aqu */

.fi
Un truco parecido funcionar para emparejar un "foo" o, un "bar" al
principio de una lnea.
.SH CMO SE EMPAREJA LA ENTRADA
Cuando el escner generado est funcionando, este analiza su entrada
buscando cadenas que concuerden con cualquiera de sus patrones.  Si
encuentra ms de un emparejamiento, toma el que empareje ms
texto (para reglas de contexto posterior, se incluye la longitud de
la parte posterior, incluso si se devuelve a la entrada).  Si encuentra
dos o ms emparejamientos de la misma longitud, se escoge la
regla listada en primer lugar en el fichero de entrada de
.I flex.
.PP
Una vez que se determina el emparejamiento, el texto correspondiente
al emparejamiento (denominado el
.I token)
est disponible en el puntero a caracter global
.B yytext,
y su longitud en la variable global entera
.B yyleng.
Entonces la
.I accin
correspondiente al patrn emparejado se ejecuta (una
descripcin ms detallada de las acciones viene a continuacin), y
entonces la entrada restante se analiza para otro emparejamiento.
.PP
Si no se encuentra un emparejamiento, entonces se ejecuta la
.I regla por defecto:
el siguiente caracter en la entrada se considera reconocido y se copia
a la salida estndar.  As, la entrada vlida ms simple de
.I flex
es:
.nf

    %%

.fi
que genera un escner que simplemente copia su entrada (un caracter a
la vez) a la salida.
.PP
Fjese que
.B yytext
se puede definir de dos maneras diferentes: bien como un
.I puntero
a caracter o como un
.I array
de caracteres.
Usted puede controlar la definicin que usa
.I flex
incluyendo una de las directivas especiales
.B %pointer
o
.B %array
en la primera seccin (definiciones) de su entrada de flex.  Por defecto es
.B %pointer,
a menos que use la opcin de compatibilidad
.B -l,
en cuyo caso
.B yytext
ser un array.
La ventaja de usar
.B %pointer
es un anlisis substancialmente ms rpido y la ausencia de
desbordamiento del buffer cuando se emparejen tokens muy grandes (a
menos que se agote la memoria dinmica).  La desventaja es que se
encuentra restringido en cmo sus acciones pueden modificar
.B yytext
(vea la siguiente seccin), y las llamadas a la funcin
.B unput()
destruyen el contenido actual de
.B yytext,
que puede convertirse en un considerable quebradero de cabeza de
portabilidad al cambiar entre diferentes versiones de
.I lex.
.PP
La ventaja de
.B %array
es que entoces puede modificar
.B yytext
todo lo que usted quiera, las llamadas a
.B unput()
no destruyen
.B yytext
(ver ms abajo).  Adems, los programas de
.I lex
existentes a veces acceden a
.B yytext
externamente utilizando declaraciones de la forma:
.nf
    extern char yytext[];
.fi
Esta definicin es errnea cuando se utiliza
.B %pointer,
pero correcta para
.B %array.
.PP
.B %array
define a
.B yytext
como un array de
.B YYLMAX
caracteres, que por defecto es un valor bastante grande.  Usted puede
cambiar el tamao smplemente definiendo con #define a
.B YYLMAX
con un valor diferente en la primera seccin de su entrada de
.I flex.
Como se mencion antes, con
.B %pointer
yytext crece dinmicamente para acomodar tokens grandes.  Aunque
esto signifique que con
.B %pointer
su escner puede acomodar tokens muy grandes (tales como emparejar
bloques enteros de comentarios), tenga presente que cada vez que el
escner deba cambiar el tamao de
.B yytext
tambin debe reiniciar el anlisis del token entero desde el
principio, as que emparejar tales tokens puede resultar lento.
Ahora
.B yytext
.I no
crece dinmicamente si una llamada a
.B unput()
hace que se deba devolver demasiado texto; en su lugar, se
produce un error en tiempo de ejecucin.
.PP
Tambin tenga en cuenta que no puede usar
.B %array
en los analizadores generados como clases de C++
(la opcin
.B c++;
vea ms abajo).
.SH ACCIONES
Cada patrn en una regla tiene una accin asociada, que puede
ser cualquier sentencia en C.  El patrn finaliza en el primer caracter
de espacio en blanco que no sea una secuencia de escape; lo que queda
de la lnea es su accin.  Si la accin est vaca, entonces cuando el
patrn se empareje el token de entrada simplemente se descarta.  Por
ejemplo, aqu est la especificacin de un programa que borra todas
las apariciones de "zap me" en su entrada:
.nf

    %%
    "zap me"

.fi
(Este copiar el resto de caracteres de la entrada a la salida ya
que sern emparejados por la regla por defecto.)
.PP
Aqu hay un programa que comprime varios espacios en blanco y tabuladores a un
solo espacio en blanco, y desecha los espacios que se encuentren al
final de una lnea:
.nf

    %%
    [ \\t]+        putchar( ' ' );
    [ \\t]+$       /* ignora este token */

.fi
.PP
Si la accin contiene un '{', entonces la accin abarca hasta que se
encuentre el correspondiente '}', y la accin podra entonces cruzar
varias lneas.
.I flex 
es capaz de reconocer las cadenas y comentarios de C y no se dejar
engaar por las llaves que encuentre dentro de estos, pero aun as
tambin permite que las acciones comiencen con
.B %{
y considerar que la accin es todo el texto hasta el siguiente
.B %}
(sin tener en cuenta las llaves ordinarias dentro de la accin).
.PP
Una accin que consista slamente de una barra vertical ('|')
significa "lo mismo que la accin para la siguiente regla."  Vea ms
abajo para una ilustracin.
.PP
Las acciones pueden incluir cdigo C arbitrario, incuyendo sentencias
.B return
para devolver un valor desde cualquier rutina llamada 
.B yylex().
Cada vez que se llama a
.B yylex()
esta contina procesando tokens desde donde lo dej la ltima vez
hasta que o bien llegue al final del fichero o ejecute un return.
.PP
Las acciones tienen libertad para modificar
.B yytext
excepto para alargarla (aadiendo caracteres al final--esto
sobreescribir ms tarde caracteres en el flujo de entrada).  Sin
embargo esto no se aplica cuando se utiliza
.B %array
(ver arriba); en ese caso,
.B yytext
podra modificarse libremente de cualquier manera.
.PP
Las acciones tienen libertad para modificar
.B yyleng
excepto que estas no deberan hacerlo si la accin tambin incluye el
uso de
.B yymore()
(ver ms abajo).
.PP
Hay un nmero de directivas especiales que pueden incluirse dentro de
una accin:
.IP -
.B ECHO
copia yytext a la salida del escner.
.IP -
.B BEGIN
seguido del nombre de la condicin de arranque pone al escner en la
condicin de arranque correspondiente (ver ms abajo).
.IP -
.B REJECT
ordena al escner a que proceda con la "segunda mejor" regla que
concuerde con la entrada (o un prefijo de la entrada).  La regla se escoge
como se describi anteriormente en "Cmo se Empareja la Entrada", y
.B yytext
e
.B yyleng
se ajustan de forma apropiada.
Podra ser una que empareje tanto texto como la regla escogida
originalmente pero que viene ms tarde en el fichero de entrada de
.I flex,
o una que empareje menos texto.
Por ejemplo, lo que viene a continuacin contar las palabras en la
entrada y llamar a la rutina especial() siempre que vea "frob":
.nf

            int contador_palabras = 0;
    %%

    frob        especial(); REJECT;
    [^ \\t\\n]+   ++contador_palabras;

.fi
Sin el
.B REJECT,
cualquier nmero de "frob"'s en la entrada no seran contados como
palabras, ya que el escner normalmente ejecuta solo una accin por
token.
Se permite el uso de mltiples
.B REJECT's,
cada uno buscando la siguiente mejor eleccin a la regla que
actualmente est activa.  Por ejemplo, cuando el siguiente escner
analice el token "abcd", este escribir "abcdabcaba" a la salida:
.nf

    %%
    a        |
    ab       |
    abc      |
    abcd     ECHO; REJECT;
    .|\\n     /* se come caracteres sin emparejar */

.fi
(Las primeras tres reglas comparten la accin de la cuarta ya que
estas usan la accin especial '|'.)
.B REJECT
es una propiedad particularmente cara en trminos de rendimiento del
escner; si se usa en
.I cualquiera
de las acciones del escner esta ralentizar
.I todo
el proceso de emparejamiento del escner.  Adems,
.B REJECT
no puede usarse con las opciones
.I -Cf
o
.I -CF
(ver ms abajo).
.IP
Fjese tambin que a diferencia de las otras acciones especiales,
.B REJECT
es una
.I bifurcacin;
el cdigo que la siga inmediatamente en la accin 
.I no
ser ejecutado.
.IP -
.B yymore()
dice al escner que la prxima vez que empareje una regla, el token
correspondiente debe ser
.I aadido
tras el valor actual de
.B yytext
en lugar de reemplazarlo.  Por ejemplo, dada la entrada "mega-klugde" lo
que viene a continuacin escribir "mega-mega-kludge" a la salida:
.nf

    %%
    mega-    ECHO; yymore();
    kludge   ECHO;

.fi
El primer "mega-" se empareja y se repite a la salida.  Entonces se
empareja "kludge", pero el "mega-" previo an est esperando al inicio
de
.B yytext
asi que el
.B ECHO
para la regla del "kludge" realmente escribir "mega-kludge".
.PP
Dos notas respecto al uso de
.B yymore().
Primero,
.B yymore()
depende de que el valor de
.I yyleng
refleje correctamente el tamao del token actual, as que no debe
modificar
.I yyleng
si est utilizando
.B yymore().
Segundo, la presencia de
.B yymore()
en la accin del escner implica una pequea penalizacin de
rendimiento en la velocidad de emparejamiento del escner.
.IP -
.B yyless(n)
devuelve todos excepto los primeros
.I n
caracteres del token actual de nuevo al flujo de entrada, donde sern
reanalizados cuando el escner busque el siguiente emparejamiento.
.B yytext
e
.B yyleng
se ajustan de forma adecuada (p.ej.,
.B yyleng
no ser igual a
.I n
).  Por ejemplo, con la entrada "foobar" lo que viene a continuacin
escribir "foobarbar":
.nf

    %%
    foobar    ECHO; yyless(3);
    [a-z]+    ECHO;

.fi
Un argumento de 0 para
.B yyless
har que la cadena de entrada actual sea analizada por completo
de nuevo.  A menos que haya cambiado la manera en la que el escner
procese de ahora en adelante su entrada (utilizando
.B BEGIN,
por ejemplo), esto producir un bucle sin fin.
.PP
Fjese que
.B yyless
es una macro y puede ser utilizada solamente en el fichero de entrada
de flex, no desde otros ficheros fuente.
.IP -
.B unput(c)
pone el caracter
.I c
de nuevo en el flujo de entrada.  Este ser el prximo caracter
analizado.  La siguiente accin tomar el token actual y har que se
vuelva a analizar pero encerrado entre parntesis.
.nf

    {
    int i;
    /* Copia yytext porque unput() desecha yytext */
    char *yycopia = strdup( yytext );
    unput( ')' );
    for ( i = yyleng - 1; i >= 0; --i )
        unput( yycopia[i] );
    unput( '(' );
    free( yycopia );
    }

.fi
Fjese que ya que cada
.B unput()
pone el caracter dado de nuevo al
.I principio
del flujo de entrada, al devolver cadenas de caracteres se debe hacer
de atrs hacia delante.
.PP
Un problema potencial importante cuando se utiliza
.B unput()
es que si est usando
.B %pointer
(por defecto), una llamada a
.B unput()
.I destruye
el contenido de
.I yytext,
comenzando con su caracter ms a la derecha y devorando un caracter a
la izquierda con cada llamada.  Si necesita que se preserve el valor
de yytext despus de una llamada a
.B unput()
(como en el ejemplo anterior),
usted debe o bien copiarlo primero en cualquier lugar, o construir su
escner usando
.B %array
 (ver Cmo se Empareja la Entrada).
.PP
Finalmente, note que no puede devolver
.B EOF
para intentar marcar el flujo de entrada con un fin-de-fichero.
.IP -
.B input()
lee el prximo caracter del flujo de entrada.  Por ejemplo,
lo que viene a continuacin es una manera de comerse los comentarios
en C:
.nf

    %%
    "/*"        {
                register int c;

                for ( ; ; )
                    {
                    while ( (c = input()) != '*' &&
                            c != EOF )
                        ;    /* se come el texto del comentario */

                    if ( c == '*' )
                        {
                        while ( (c = input()) == '*' )
                            ;
                        if ( c == '/' )
                            break;    /* encontr el final */
                        }

                    if ( c == EOF )
                        {
                        error( "EOF en comentario" );
                        break;
                        }
                    }
                }

.fi
(Fjese que si el escner se compila usando
.B C++,
entonces a
.B input()
se le hace referencia con
.B yyinput(),
para evitar una colisin de nombre con el flujo de
.B C++
por el nombre
.I input.)
.IP -
.B YY_FLUSH_BUFFER
vaca el buffer interno del escner
de manera que la prxima vez que el escner intente emparejar un
token, este primero rellenar el buffer usando
.B YY_INPUT
(ver El Escner Generado, ms abajo).  Esta accin es un caso especial
de la funcin ms general
.B yy_flush_buffer(),
descrita ms abajo en la seccin Mltiples Buffers de Entrada.
.IP -
.B yyterminate()
se puede utilizar en lugar de una sentencia de retorno en una accin.
Esta hace que finalice el escner y retorne un 0 a quien haya llamado
al escner, indicando que "todo est hecho".  Por defecto, tambin se
llama a
.B yyterminate()
cuando se encuentra un fin-de-fichero.  Esta es una macro y podra ser
redefinida.
.SH El Escner Generado
La salida de
.I flex
es el fichero
.B lex.yy.c,
que contiene la rutina de anlisis
.B yylex(),
un nmero de tablas usadas por esta para emparejar tokens, y un nmero
de rutinas auxiliares y macros.  Por defecto,
.B yylex()
se declara as
.nf

    int yylex()
        {
        ... aqu van varias definiciones y las acciones ...
        }

.fi
(Si su entorno acepta prototipos de funciones, entonces este ser
"int yylex( void )").  Esta definicin podra modificarse definiendo
la macro "YY_DECL".  Por ejemplo, podra utilizar:
.nf

    #define YY_DECL float lexscan( a, b ) float a, b;

.fi
para darle a la rutina de anlisis el nombre
.I lexscan,
que devuelve un real, y toma dos reales como argumentos.  Fjese que
si pone argumentos a la rutina de anlisis usando una declaracin de
funcin no-prototipada/tipo-K&R, debe hacer terminar la definicin con
un punto y coma (;).
.PP
Siempre que se llame a
.B yylex(),
este analiza tokens desde el fichero de entrada global
.I yyin
(que por defecto es igual a stdin).  La funcin contina hasta que
alcance el final del fichero (punto en el que devuelve el valor 0) o
una de sus acciones ejecute una sentencia
.I return.
.PP
Si el escner alcanza un fin-de-fichero, entonces el comportamiento
en las llamadas posteriores est indefinido a menos que o bien
.I yyin
apunte a un nuevo fichero de entrada (en cuyo caso el anlisis
contina a partir de ese fichero), o se llame a
.B yyrestart().
.B yyrestart()
toma un argumento, un puntero
.B FILE *
(que puede ser nulo, si ha preparado a
.B YY_INPUT
para que analice una fuente distinta a
.I yyin),
e inicializa 
.I yyin
para que escanee ese fichero.  Esencialmente no hay diferencia
entre la asignacin a
.I yyin
de un nuevo fichero de entrada o el uso de
.B yyrestart()
para hacerlo; esto ltimo est disponible por compatibilidad con
versiones anteriores de
.I flex,
y porque puede utilizarse para conmutar ficheros de entrada en medio
del anlisis.  Tambin se puede utilizar para desechar el buffer de
entrada actual, invocndola con un argumento igual a
.I yyin;
pero mejor es usar
.B YY_FLUSH_BUFFER
(ver ms arriba).
Fjese que
.B yyrestart()
.I no
reinicializa la condicin de arranque a
.B INITIAL
(ver Condiciones de Arranque, ms abajo).
.PP
Si
.B yylex()
para el anlisis debido a la ejecucin de una sentencia
.I return
en una de las acciones, el analizador podra ser llamado de nuevo y
este reanudara el anlisis donde lo dej.
.PP
Por defecto (y por razones de eficiencia), el analizador usa
lecturas por bloques en lugar de simples llamadas a
.I getc()
para leer caracteres desde
.I yyin.
La manera en la que toma su entrada se puede controlar definienfo la
macro
.B YY_INPUT.
La secuencia de llamada para YY_INPUT es
"YY_INPUT(buf,result,max_size)".  Su accin es poner hasta
.I max_size
caracteres en el array de caracteres
.I buf
y devolver en la variable entera
.I result
bien o el nmero de caracteres ledos o la constante YY_NULL (0 en
sistemas Unix) para indicar EOF.  Por defecto YY_INPUT lee desde la
variable global puntero a fichero "yyin".
.PP
Una definicin de ejemplo para YY_INPUT (en la seccin de definiciones
del fichero de entrada) es:
.nf

    %{
    #define YY_INPUT(buf,result,max_size) \\
        { \\
        int c = getchar(); \\
        result = (c == EOF) ? YY_NULL : (buf[0] = c, 1); \\
        }
    %}

.fi
Esta definicin cambiar el procesamiento de la entrada para que
suceda un caracter a la vez.
.PP
Cuando el analizador reciba una indicacin de fin-de-fichero desde
YY_INPUT, entonces esta comprueba la funcin
.B yywrap().
Si
.B yywrap()
devuelve falso (cero), entonces se asume que la funcin ha ido ms all
y ha preparado
.I yyin
para que apunte a otro fichero de entrada, y el anlisis contina.  Si
este retorna verdadero (no-cero), entonces el analizador termina,
devolviendo un 0 a su invocador.  Fjese que en cualquier caso, la
condicin de arranque permanece sin cambios;
esta
.I no
vuelve a ser
.B INITIAL.
.PP
Si no proporciona su propia versin de
.B yywrap(),
entonces debe bien o usar
.B %option noyywrap
(en cuyo caso el analizador se comporta como si
.B yywrap()
devolviera un 1), o debe enlazar con
.B \-lfl
para obtener la versin por defecto de la rutina, que siempre devuelve
un 1.
.PP
Hay disponibles tres rutinas para analizar desde buffers de memoria en
lugar de desde ficheros:
.B yy_scan_string(), yy_scan_bytes(),
e
.B yy_scan_buffer().
Las trataremos en la seccin Mltiples Buffers de Entrada.
.PP
El analizador escribe su salida con
.B ECHO
a la variable global
.I yyout
(por defecto, stdout), que el usuario podra redefinir asignndole
cualquier otro puntero a
.B FILE.
.SH CONDICIONES DE ARRANQUE
.I flex
dispone de un mecanismo para activar reglas condicionalmente.
Cualquier regla cuyo patrn se prefije con "<sc>" nicamente estar
activa cuando el analizador se encuentre en la condicin de arranque
llamada "sc".  Por ejemplo,
.nf

    <STRING>[^"]*        { /* se come el cuerpo de la cadena ... */
                ...
                }

.fi
estar activa solamente cuando el analizador est en la condicin de
arranque "STRING", y
.nf

    <INITIAL,STRING,QUOTE>\\. { /* trata una secuencia de escape ... */
                ...
                }

.fi
estar activa solamente cuando la condicin de arranque actual sea
o bien "INITIAL", "STRING", o "QUOTE".
.PP
Las condiciones de arranque se declaran en la (primera) seccin de
definiciones de la entrada usando lneas sin sangrar comenzando con
.B %s
o
.B %x
seguida por una lista de nombres.
Lo primero declara condiciones de arranque
.I inclusivas,
lo ltimo condiciones de arranque
.I exclusivas.
Una condicin de arranque se activa utilizando la accin
.B BEGIN.
Hasta que se ejecute la prxima accin
.B BEGIN,
las reglas con la condicin de arranque dada estarn activas y las
reglas con otras condiciones de arranque estarn inactivas.
Si la condicin de arranque es
.I inclusiva,
entonces las reglas sin condiciones de arranque tambin estarn
activas. Si es
.I exclusiva,
entonces
.I slamente
las reglas calificadas con la condicin de arranque estarn
activas. Un conjunto de reglas dependientes de la misma condicin de
arranque exclusiva describe un analizador que es independiente de
cualquiera de las otras reglas en la entrada de
.I flex.
Debido a esto, las condiciones de arranque exclusivas hacen fcil la
especificacin de "mini-escneres" que analizan porciones de la entrada
que son sintcticamente diferentes al resto (p.ej., comentarios).
.PP
Si la distincin entre condiciones de arranque inclusivas o exclusivas
es an un poco vaga, aqu hay un ejemplo simple que ilustra la
conexin entre las dos.  El conjunto de reglas:
.nf

    %s ejemplo
    %%

    <ejemplo>foo   hacer_algo();

    bar            algo_mas();

.fi
es equivalente a
.nf

    %x ejemplo
    %%

    <ejemplo>foo   hacer_algo();

    <INITIAL,ejemplo>bar    algo_mas();

.fi
Sin el calificador
.B <INITIAL,example>,
el patrn
.I bar
en el segundo ejemplo no estar activo (es decir, no puede emparejarse)
cuando se encuentre en la condicin de arranque
.B example.
Si hemos usado
.B <example>
para calificar
.I bar,
aunque, entonces este nicamente estar activo en
.B example
y no en
.B INITIAL,
mientras que en el primer ejemplo est activo en ambas, porque en el
primer ejemplo la condicin de arranque
.B example
es una condicin de arranque
.I inclusiva
.B (%s).
.PP
Fjese tambin que el especificador especial de la condicin de arranque
.B <*>
empareja todas las condiciones de arranque.  As, el ejemplo anterior
tambin pudo haberse escrito;
.nf

    %x ejemplo
    %%

    <ejemplo>foo   hacer_algo();

    <*>bar    algo_mas();

.fi
.PP
La regla por defecto (hacer un
.B ECHO
con cualquier caracter sin emparejar) permanece activa en las
condiciones de arranque.  Esta es equivalente a:
.nf

    <*>.|\\n     ECHO;

.fi
.PP
.B BEGIN(0)
retorna al estado original donde solo las reglas sin condiciones de
arranque estn activas.  Este estado tambin puede referirse a la
condicin de arranque "INITIAL", as que
.B BEGIN(INITIAL)
es equivalente a
.B BEGIN(0).
(No se requieren los parntesis alrededor del nombre de la condicin
de arranque pero se considera de buen estilo.)
.PP
Las acciones
.B BEGIN
pueden darse tambin como cdigo sangrado al comienzo de la seccin
de reglas.  Por ejemplo, lo que viene a continuacin har que el
analizador entre en la condicin de arranque "ESPECIAL" siempre que se
llame a 
.B yylex()
y la variable global
.I entra_en_especial
sea verdadera:
.nf

            int entra_en_especial;

    %x ESPECIAL
    %%
            if ( entra_en_especial )
                BEGIN(ESPECIAL);

    <ESPECIAL>blablabla
    ...ms reglas a continuacin...

.fi
.PP
Para ilustrar los usos de las condiciones de arranque, aqu hay un
analizador que ofrece dos interpretaciones diferentes para una cadena
como "123.456".  Por defecto este la tratar como tres tokens, el
entero "123", un punto ('.'), y el entero "456".  Pero si la cadena
viene precedida en la lnea por la cadena "espera-reales" este la
tratar como un nico token, el nmero en coma flotante 123.456:
.nf

    %{
    #include <math.h>
    %}
    %s espera

    %%
    espera-reales        BEGIN(espera);

    <espera>[0-9]+"."[0-9]+      {
                printf( "encontr un real, = %f\\n",
                        atof( yytext ) );
                }
    <espera>\\n           {
                /* este es el final de la lnea,
                 * as que necesitamos otro
                 * "espera-numero" antes de
                 * que volvamos a reconocer ms
                 * nmeros
                 */
                BEGIN(INITIAL);
                }

    [0-9]+      {
                printf( "encontr un entero, = %d\\n",
                        atoi( yytext ) );
                }

    "."         printf( "encontr un punto\\n" );

.fi
Aqu est un analizador que reconoce (y descarta) comentarios de C
mientras mantiene una cuenta de la lnea actual de entrada.
.nf

    %x comentario
    %%
            int num_linea = 1;

    "/*"         BEGIN(comentario);

    <comentario>[^*\\n]*       /* come todo lo que no sea '*' */
    <comentario>"*"+[^*/\\n]*  /* come '*'s no seguidos por '/' */
    <comentario>\\n            ++num_linea;
    <comentario>"*"+"/"       BEGIN(INITIAL);

.fi
Este analizador se complica un poco para emparejar tanto texto
como le sea posible en cada regla.  En general, cuando se intenta
escribir un analizador de alta velocidad haga que cada regla empareje
lo ms que pueda, ya que esto es un buen logro.
.PP
Fjese que los nombres de las condiciones de arranque son realmente
valores enteros y pueden ser almacenados como tales.  As, lo anterior
podra extenderse de la siguiente manera:
.nf

    %x comentario foo
    %%
            int num_linea = 1;
            int invocador_comentario;

    "/*"         {
                 invocador_comentario = INITIAL;
                 BEGIN(comentario);
                 }

    ...

    <foo>"/*"    {
                 invocador_comentario = foo;
                 BEGIN(comentario);
                 }

    <comentario>[^*\\n]*        /* se come cualquier cosa que no sea un '*' */
    <comentario>"*"+[^*/\\n]*   /* se come '*'s que no continuen con '/'s */
    <comentario>\\n             ++num_linea;
    <comentario>"*"+"/"        BEGIN(invocador_comentario);

.fi
Adems, puede acceder a la condicin de arranque actual usando la
macro de valor entero
.B YY_START.
Por ejemplo, las asignaciones anteriores a
.I invocador_comentario
podran escribirse en su lugar como
.nf

    invocador_comentario = YY_START;

.fi
Flex ofrece
.B YYSTATE
como un alias para
.B YY_START
(ya que es lo que usa
.I lex
de AT&T).
.PP
Fjese que las condiciones de arranque no tienen su propio espacio de
nombres; los %s's y %x's declaran nombres de la misma manera que con
#define's.
.PP
Finalmente, aqu hay un ejemplo de cmo emparejar cadenas entre
comillas al estilo de C usando condiciones de arranque exclusivas,
incluyendo secuencias de escape expandidas (pero sin incluir la
comprobacin de cadenas que son demasiado largas):
.nf

    %x str

    %%
            char string_buf[MAX_STR_CONST];
            char *string_buf_ptr;


    \\"      string_buf_ptr = string_buf; BEGIN(str);

    <str>\\"        { /* se vio la comilla que cierra - todo est hecho */
            BEGIN(INITIAL);
            *string_buf_ptr = '\\0';
            /* devuelve un tipo de token de cadena constante y
             * el valor para el analizador sintctico
             */
            }

    <str>\\n        {
            /* error - cadena constante sin finalizar */
            /* genera un mensaje de error */
            }

    <str>\\\\[0-7]{1,3} {
            /* secuencia de escape en octal */
            int resultado;

            (void) sscanf( yytext + 1, "%o", &resultado );

            if ( resultado > 0xff )
                    /* error, constante fuera de rango */

            *string_buf_ptr++ = resultado;
            }

    <str>\\\\[0-9]+ {
            /* genera un error - secuencia de escape errnea;
             * algo como '\\48' o '\\0777777'
             */
            }

    <str>\\\\n  *string_buf_ptr++ = '\\n';
    <str>\\\\t  *string_buf_ptr++ = '\\t';
    <str>\\\\r  *string_buf_ptr++ = '\\r';
    <str>\\\\b  *string_buf_ptr++ = '\\b';
    <str>\\\\f  *string_buf_ptr++ = '\\f';

    <str>\\\\(.|\\n)  *string_buf_ptr++ = yytext[1];

    <str>[^\\\\\\n\\"]+        {
            char *yptr = yytext;

            while ( *yptr )
                    *string_buf_ptr++ = *yptr++;
            }

.fi
.PP
A menudo, como en alguno de los ejemplos anteriores, uno acaba
escribiendo un buen nmero de reglas todas precedidas por la(s) misma(s)
condicin(es) de arranque.  Flex hace esto un poco ms fcil y claro
introduciendo la nocin de
.I mbito
de la condicin de arranque.  Un mbito de condicin de arranque
comienza con:
.nf

    <SCs>{

.fi
Donde
.I SCs
es una lista de una o ms condiciones de arranque.  Dentro del mbito
de la condicin de arranque, cada regla automticamente tiene el
prefijo
.I <SCs>
aplicado a esta, hasta un
.I '}'
que corresponda con el
.I '{'
inicial.
As, por ejemplo,
.nf

    <ESC>{
        "\\\\n"   return '\\n';
        "\\\\r"   return '\\r';
        "\\\\f"   return '\\f';
        "\\\\0"   return '\\0';
    }

.fi
es equivalente a:
.nf

    <ESC>"\\\\n"  return '\\n';
    <ESC>"\\\\r"  return '\\r';
    <ESC>"\\\\f"  return '\\f';
    <ESC>"\\\\0"  return '\\0';

.fi
Los mbitos de las condiciones de arranque pueden anidarse.
.PP
Estn disponibles tres rutinas para manipular pilas de condiciones de
arranque:
.TP
.B void yy_push_state(int new_state)
empuja la condicin de arranque actual al tope de la pila de las
condiciones de arranque y cambia a
.I new_state
como si hubiera utilizado
.B BEGIN new_state
(recuerde que los nombres de las condiciones de arranque tambin son
enteros).
.TP
.B void yy_pop_state()
extrae el tope de la pila y cambia a este mediante un
.B BEGIN.
.TP
.B int yy_top_state()
devuelve el tope de la pila sin alterar el contenido de la pila.
.PP
La pila de las condiciones de arranque crece dinmicamente y por ello
no tiene asociada ninguna limitacin de tamao.  Si la memoria se
agota, se aborta la ejecucin del programa.
.PP
Para usar pilas de condiciones de arranque, su analizador debe incluir
una directiva
.B %option stack
(ver Opciones ms abajo).
.SH MLTIPLES BUFFERS DE ENTRADA
Algunos analizadores (tales como aquellos que aceptan ficheros
"incluidos") requieren la lectura de varios flujos de entrada.  Ya que
los analizadores de 
.I flex
hacen mucho uso de buffers, uno no puede controlar de dnde
ser leda la siguiente entrada escribiendo smplemente un
.B YY_INPUT
que sea sensible al contexto del anlisis.
A
.B YY_INPUT
slo se le llama cuando el analizador alcanza el final de su buffer,
que podra ser bastante tiempo despus de haber analizado una
sentencia como un "include" que requiere el cambio de la fuente de
entrada.
.PP
Para solventar este tipo de problemas,
.I flex
provee un mecanismo para crear y conmutar entre varios buffers de
entrada.  Un buffer de entrada se crea usando:
.nf

    YY_BUFFER_STATE yy_create_buffer( FILE *file, int size )

.fi
que toma un puntero a
.I FILE
y un tamao "size" y crea un buffer asociado con el fichero dado y lo
suficientemente grande para mantener 
.I size
caracteres (cuando dude, use
.B YY_BUF_SIZE
para el tamao).  Este devuelve un handle
.B YY_BUFFER_STATE,
que podra pasarse a otras rutinas (ver ms abajo).  El tipo de
.B YY_BUFFER_STATE
es un puntero a una estructura opaca
.B struct yy_buffer_state,
de manera que podra inicializar de forma segura variables
YY_BUFFER_STATE a
.B ((YY_BUFFER_STATE) 0)
si lo desea, y tambin hacer referencia a la estructura opaca para
declarar correctamente buffers de entrada en otros ficheros fuente
adems de los de su analizador.  Fjese que el puntero a
.I FILE
en la llamada a
.B yy_create_buffer
se usa solamente como el valor de
.I yyin
visto por
.B YY_INPUT;
si usted redefine
.B YY_INPUT
de manera que no use ms a
.I yyin,
entonces puede pasar de forma segura un puntero
.I FILE
nulo a
.B yy_create_buffer.
Se selecciona un buffer en particular a analizar utilizando:
.nf

    void yy_switch_to_buffer( YY_BUFFER_STATE nuevo_buffer )

.fi
conmuta el buffer de entrada del analizador de manera que los tokens
posteriores provienen de
.I nuevo_buffer.
Fjese que
.B yy_switch_to_buffer()
podra usarlo yywrap() para arreglar las cosas para un anlisis
continuo, en lugar de abrir un nuevo fichero y que
.I yyin
apunte a este.  Fjese tambin que cambiar las fuentes de entrada ya
sea por medio de
.B yy_switch_to_buffer()
o de
.B yywrap()
.I no
cambia la condicin de arranque.
.nf

    void yy_delete_buffer( YY_BUFFER_STATE buffer )

.fi
se usa para recuperar el almacenamiento asociado a un buffer.  (El
.B buffer
puede ser nulo, en cuyo caso la rutina no hace nada.)
Puede tambin limpiar el contenido actual de un buffer usando:
.nf

    void yy_flush_buffer( YY_BUFFER_STATE buffer )

.fi
Esta funcin descarta el contenido del buffer, de manera que la
prxima vez que el analizador intente emparejar un token desde el
buffer, este primero rellenar el buffer utilizando
.B YY_INPUT.
.PP
.B yy_new_buffer()
es un alias de
.B yy_create_buffer(),
que se ofrece por compatibilidad con el uso en C++ de
.I new
y
.I delete
para crear y destruir objetos dinmicos.
.PP
Finalmente, la macro
.B YY_CURRENT_BUFFER
retorna un handle
.B YY_BUFFER_STATE
al buffer actual.
.PP
Aqu hay un ejemplo del uso de estas propiedades para escribir un
analizador que expande ficheros incluidos (la propiedad
.B <<EOF>>
se comenta ms abajo):
.nf

    /* el estado "incl" se utiliza para obtener el nombre
     * del fichero a incluir.
     */
    %x incl

    %{
    #define MAX_INCLUDE_DEPTH 10
    YY_BUFFER_STATE include_stack[MAX_INCLUDE_DEPTH];
    int include_stack_ptr = 0;
    %}

    %%
    include             BEGIN(incl);

    [a-z]+              ECHO;
    [^a-z\\n]*\\n?        ECHO;

    <incl>[ \\t]*      /* se come los espacios en blanco */
    <incl>[^ \\t\\n]+   { /* obtiene el nombre de fichero a incluir */
            if ( include_stack_ptr >= MAX_INCLUDE_DEPTH )
                {
                fprintf( stderr, "Demasiados include anidados" );
                exit( 1 );
                }

            include_stack[include_stack_ptr++] =
                YY_CURRENT_BUFFER;

            yyin = fopen( yytext, "r" );

            if ( ! yyin )
                error( ... );

            yy_switch_to_buffer(
                yy_create_buffer( yyin, YY_BUF_SIZE ) );

            BEGIN(INITIAL);
            }

    <<EOF>> {
            if ( --include_stack_ptr < 0 )
                {
                yyterminate();
                }

            else
                {
                yy_delete_buffer( YY_CURRENT_BUFFER );
                yy_switch_to_buffer(
                     include_stack[include_stack_ptr] );
                }
            }

.fi
Se dispone de tres rutinas para preparar buffers de entrada para el
anlisis de cadenas en memoria en lugar de archivos.  Todas estas
crean un nuevo buffer de entrada para analizar la cadena, y devuelven
el correspondiente handle
.B YY_BUFFER_STATE
(que usted debera borrar con
.B yy_delete_buffer()
cuando termine con l).  Estas tambin conmutan el nuevo buffer usando
.B yy_switch_to_buffer(),
de manera que la prxima llamada a
.B yylex()
comenzar analizando la cadena.
.TP
.B yy_scan_string(const char *str)
analiza una cadena terminada en nulo.
.TP
.B yy_scan_bytes(const char *bytes, int len)
analiza
.I len
bytes (incluyendo posibles NUL's)
comenzando desde el punto
.I bytes.
.PP
Fjese que ambas de estas funciones crean y analizan una
.I copia
de la cadena o bytes.  (Esto podra ser deseable, ya que
.B yylex()
modifica el contenido del buffer que est analizado.)  Usted puede
evitar la copia utilizando:
.TP
.B yy_scan_buffer(char *base, yy_size_t size)
que analiza in situ el buffer comenzando en
.I base,
que consiste de
.I size
bytes, donde los dos ltimos bytes
.I deben
ser
.B YY_END_OF_BUFFER_CHAR
(ASCII NUL).
Estos dos ltimos bytes no se analizan; as, el anlisis consta de
.B base[0]
hasta
.B base[size-2],
inclusive.
.IP
Si se equivoca al disponer
.I base
de esta manera (es decir, olvidar los dos
.B YY_END_OF_BUFFER_CHAR
bytes finales), entonces
.B yy_scan_buffer()
devuelve un puntero nulo en lugar de crear un nuevo buffer de entrada.
.IP
El tipo
.B yy_size_t
es un tipo entero con el que puede hacer una conversin a una expresin
entera para reflejar el tamao del buffer.
.SH REGLAS DE FIN-DE-FICHERO
La regla especial "<<EOF>>" indica las acciones que deben tomarse
cuando se encuentre un fin-de-fichero e yywrap() retorne un valor
distinto de cero
(es decir, indica que no quedan ficheros por procesar).  La accin
debe finalizar haciendo una de estas cuatro cosas:
.IP -
asignando a
.I yyin
un nuevo fichero de entrada (en versiones anteriores de flex, despus
de hacer la asignacin deba llamar a la accin especial
.B YY_NEW_FILE;
esto ya no es necesario);
.IP -
ejecutando una sentencia
.I return;
.IP -
ejecutando la accin especial
.B yyterminate();
.IP -
o, conmutando a un nuevo buffer usando
.B yy_switch_to_buffer()
como se mostr en el ejemplo anterior.
.PP
Las reglas <<EOF>> no deberan usarse con otros patrones; estas
deberan calificarse con una lista de condiciones de arranque.  Si se
da una regla <<EOF>> sin calificar, esta se aplica a
.I todas
las condiciones de arranque que no tengan ya acciones <<EOF>>.  Para
especificar una regla <<EOF>> solamente para la condicin de arranque
inicial, use
.nf

    <INITIAL><<EOF>>

.fi
.PP
Estas reglas son tiles para atrapar cosas tales como comentarios sin
final.
Un ejemplo:
.nf

    %x comilla
    %%

    ...otras reglas que tengan que ver con comillas...

    <comilla><<EOF>>   {
             error( "comilla sin cerrar" );
             yyterminate();
             }
    <<EOF>>  {
             if ( *++filelist )
                 yyin = fopen( *filelist, "r" );
             else
                yyterminate();
             }

.fi
.SH MACROS MISCELNEAS
La macro
.B YY_USER_ACTION
puede definirse para indicar una accin que siempre se ejecuta antes
de la accin de la regla emparejada.  Por ejemplo, podra declararse con
#define para que llame a una rutina que convierta yytext a minsculas.
Cuando se invoca a
.B YY_USER_ACTION,
la variable
.I yy_act
da el nmero de la regla emparejada (las reglas estn numeradas
comenzando en 1).  Suponga que quiere medir la frecuencia con la que
sus reglas son emparejadas.  Lo que viene a continuacin podra hacer
este truco:
.nf

    #define YY_USER_ACTION ++ctr[yy_act]

.fi
donde
.I ctr
en un vector que mantiene la cuenta para las diferentes reglas.  Fjese
que la macro
.B YY_NUM_RULES
da el nmero total de reglas (incluyendo la regla por defecto, incluso
si usted usa
.B \-s),
as que una declaracin correcta para
.I ctr
es:
.nf

    int ctr[YY_NUM_RULES];

.fi
.PP
La macro
.B YY_USER_INIT
podra definirse para indicar una accin que siempre se ejecuta antes
del primer anlisis (y antes de que se haga la inicializacin interna
del analizador).  Por ejemplo, este podra usarse para llamar a una
rutina que lea una tabla de datos o abrir un fichero de registro.
.PP
La macro
.B yy_set_interactive(is_interactive)
se puede usar para controlar si el buffer actual se considera
.I interactivo.
Un buffer interactivo se procesa ms lentamente, pero debe usarse
cuando la fuente de entrada del analizador es realmente interactiva
para evitar problemas debidos a la espera para el llenado de los
buffers (ver el comentario de la bandera
.B \-I
ms abajo).  Un valor distinto de cero
en la invocacin de la macro marcar el buffer como interactivo, un
valor de cero como no-interactivo.  Fjese que el uso de esta macro no
tiene en cuenta
.B %option always-interactive
o
.B %option never-interactive
(ver Opciones ms abajo).
.B yy_set_interactive()
debe invocarse antes del comienzo del anlisis del buffer que es
considerado (o no) interactivo.
.PP
La macro
.B yy_set_bol(at_bol)
puede usarse para controlar si el contexto del buffer de anlisis
actual para el prximo emparejamiento de token se hace como si se
encontrara al principio de una lnea.  Un argumento de la macro
distinto de cero hace activas a las reglas sujetas a '^', mientras que
un argumento igual a cero hacer inactivas a las reglas con '^'.
.PP
La macro
.B YY_AT_BOL()
devuelve verdadero si el prximo token analizado a partir del buffer
actual tendr activas las reglas '^', de otra manera falso.
.PP
En el analizador generado, las acciones estn recogidas en una gran
sentencia switch y separadas usando
.B YY_BREAK,
que puede ser redefinida.  Por defecto, este es smplemente un
"break", para separar la accin de cada regla de las reglas que le
siguen.
Redefiniendo
.B YY_BREAK
permite, por ejemplo, a los usuarios de C++ que #define YY_BREAK no
haga nada (mientras tengan cuidado para que cada regla finalice con un
"break" o un "return"!) para evitar que sufran los avisos de
sentencias inalcanzables cuando debido a que la accin de la regla
finaliza con un "return", el
.B YY_BREAK
es inaccesible.
.SH VALORES DISPONIBLES AL USUARIO
Esta seccin resume los diferentes valores disponibles al usuario en
las acciones de la regla.
.IP -
.B char *yytext
apunta al texto del token actual.  Este puede modificarse pero no
alargarse (no puede aadir caracteres al final).
.IP
Si aparece la directiva especial
.B %array
en la primera seccin de la descripcin del analizador, entonces
.B yytext
se declara en su lugar como
.B char yytext[YYLMAX],
donde
.B YYLMAX
es la definicion de una macro que puede redefinir en la primera
seccin si no le gusta el valor por defecto (generalmente 8KB).  El
uso de
.B %array
produce analizadores algo ms lentos, pero el valor de
.B yytext
se vuelve inmune a las llamadas a
.I input()
y
.I unput(),
que potencialmente destruyen su valor cuando
.B yytext
es un puntero a caracter.  El opuesto de
.B %array
es
.B %pointer,
que se encuentra por defecto.
.IP
Usted no puede utilizar
.B %array
cuando genera analizadores como clases de C++
(la bandera
.B \-+
).
.IP -
.B int yyleng
contiene la longitud del token actual.
.IP -
.B FILE *yyin
es el fichero por el que
.I flex
lee por defecto.  Este podra redefinirse pero hacerlo solo tiene
sentido antes de que el anlisis comience o despus de que se haya
encontrado un EOF.  Cambindolo en medio del anlisis tendr resultados
inesperados ya que
.I flex
utiliza buffers en su entrada; use
.B yyrestart()
en su lugar.
Una vez que el anlisis termina debido a que se ha visto un
fin-de-fichero, puede asignarle a
.I yyin
el nuevo fichero de entrada y entonces llamar al analizador de nuevo
para continuar analizando.
.IP -
.B void yyrestart( FILE *new_file )
podra ser llamada para que
.I yyin
apunte al nuevo fichero de entrada.  El cambio al nuevo fichero es
inmediato (cualquier entrada contenida en el buffer previamente se
pierde).  Fjese que llamando a
.B yyrestart()
con
.I yyin
como argumento de esta manera elimina el buffer de entradda actual y
contina analizando el mismo fichero de entrada.
.IP -
.B FILE *yyout
es el fichero sobre el que se hacen las acciones
.B ECHO.
Este puede ser reasignado por el usuario.
.IP -
.B YY_CURRENT_BUFFER
devuelve un handle
.B YY_BUFFER_STATE
al buffer actual.
.IP -
.B YY_START
devuelve un valor entero correspondiente a la condicin de arranque
actual.  Posteriormente puede usar este valor con
.B BEGIN
para retornar a la condicin de arranque.
.SH INTERFAZ CON YACC
Uno de los usos principales de
.I flex
es como compaero del generador de analizadores sintcticos
.I yacc.
Los analizadores de
.I yacc
esperan invocar a una rutina llamada
.B yylex()
para encontrar el prximo token de entrada.  La rutina se supone que
devuelve el tipo del prximo token adems de poner cualquier valor
asociado en la variable global
.B yylval.
Para usar
.I flex
con
.I yacc,
uno especifica la opcin
.B \-d
de
.I yacc
para intruirle a que genere el fichero
.B y.tab.h
que contiene las definiciones de todos los
.B %tokens
que aparecen en la entrada de
.I yacc.
Entonces este archivo se incluye en el analizador de
.I flex
Por ejemplo, si uno de los tokens es "TOK_NUMERO", parte del
analizador podra parecerse a:
.nf

    %{
    #include "y.tab.h"
    %}

    %%

    [0-9]+        yylval = atoi( yytext ); return TOK_NUMERO;

.fi
.SH OPCIONES
.I flex
tiene las siguientes opciones:
.TP
.B \-b
Genera informacin de retroceso en
.I lex.backup.
Esta es una lista de estados del analizador que requieren retroceso
y los caracteres de entrada con los que la hace.  Aadiendo reglas uno
puede eliminar estados de retroceso.  Si
.I todos
los estados de retroceso se eliminan y se usa
.B \-Cf
o
.B \-CF,
el analizador generado funcionar ms rpido (ver la bandera
.B \-p).
nicamente los usuarios que desean exprimir hasta el ltimo ciclo de sus
analizadores necesitan preocuparse de esta opcin.  (Ver la seccin
sobre Consideraciones de Rendimiento ms abajo.)
.TP
.B \-c
es una opcin que no hace nada, includa para cumplir con POSIX.
.TP
.B \-d
hace que el analizador generado se ejecute en modo de
.I depuracin.
Siempre que se reconoce un patrn y la variable global
.B yy_flex_debug
no es cero (que por defecto no lo es),
el analizador escribir en
.I stderr
una lnea de la forma:
.nf

    --accepting rule at line 53 ("el texto emparejado")

.fi
El nmero de lnea hace referencia al lugar de la regla en el fichero
que define al analizador (es decir, el fichero que se le introdujo a
flex).  Los mensajes tambin se generan cuando el analizador
retrocede, acepta la regla por defecto, alcanza el final de su buffer
de entrada (o encuentra un NUL; en este punto, los dos parecen lo
mismo en lo que le concierne al analizador), o alcance el
fin-de-fichero.
.TP
.B \-f
especifica un
.I analizador rpido.
No se realiza una compresin de tablas y se evita el uso de stdio.
El resultado es grande pero rpido.  Esta opcin es equivalente a
.B \-Cfr
(ver ms abajo).
.TP
.B \-h
genera un sumario de "ayuda" de las opciones de
.I flex
por
.I stdout 
y entonces finaliza.
.B \-?
y
.B \-\-help
son sinnimos de
.B \-h.
.TP
.B \-i
indica a
.I flex
que genere un analizador
.I case-insensitive.
Se ignorar si las letras en los patrones de entrada de
.I flex
son en maysculas o en minsculas, y los tokens en la entrada sern
emparejados sin tenerlo en cuenta.  El texto emparejado dado en
.I yytext
tendr las maysculas y minsculas preservadas (es decir, no se
convertirn).
.TP
.B \-l
activa el modo de mxima compatibilidad con la implementacin original
de
.I lex
de AT&T.
Fjese que esto no significa una compatibilidad
.I completa.
El uso de esta opcin cuesta una cantidad considerable de
rendimiento, y no puede usarse con las opciones
.B \-+, -f, -F, -Cf,
o
.B -CF.
Para los detalles a cerca de la compatibilidad que se ofrece, vea la
seccin "Incompatibilidades con Lex y POSIX" ms abajo.  Esta opcin
tambin hace que se defina el nombre
.B YY_FLEX_LEX_COMPAT
en el analizador generado.
.TP
.B \-n
es otra opcin que no hace nada, includa para cumplir con POSIX.
.TP
.B \-p
genera un informe de rendimiento en stderr.  El informe consta de
comentarios que tratan de las propiedades del fichero de entrada de
.I flex
que provocarn prdidas serias de rendimiento en el analizador
resultante.  Si indica esta bandera dos veces, tambin obtendr
comentarios que tratan de las propiedades que producen prdidas
menores de rendimiento.
.IP
Fjese que el uso de
.B REJECT,
.B %option yylineno,
y el contexto posterior variable (vea la seccin Deficiencias /
Errores ms abajo) supone una penalizacin substancial del
rendimiento;  el uso de
.I yymore(),
el operador
.B ^,
y la bandera
.B \-I
supone penalizaciones del rendimiento menores.
.TP
.B \-s
hace que la
.I regla por defecto
(que la entrada sin emparejar del analizador se repita por
.I stdout)
se suprima.  Si el analizador encuentra entrada que no es reconocida
por ninguna de sus reglas, este aborta con un error.  Esta opcin es
til para encontrar agujeros en el conjunto de reglas del analizador.
.TP
.B \-t
indica a
.I flex
que escriba el analizador que genera a la salida estndar en lugar de en
.B lex.yy.c.
.TP
.B \-v
especifica que
.I flex
debera escribir en
.I stderr
un sumario de estadsticas respecto al analizador que genera.
La mayora de las estadsticas no tienen significado para el usuario
casual de
.I flex,
pero la primera lnea identifica la versin de
.I flex
(la misma que se informa con
.B \-V),
y la prxima lnea las banderas utilizadas cuando se genera el
analizador, incluyendo aquellas que se encuentran activadas por defecto.
.TP
.B \-w
suprime los mensajes de aviso.
.TP
.B \-B
dice a
.I flex
que genere un analizador
.I batch,
que es lo opuesto al analizador 
.I interactivo
generador por
.B \-I
(ver ms abajo).  En general, use
.B \-B
cuando est
.I seguro
de que su analizador nunca se usar de forma interactiva, y quiere
con esto exprimir un
.I poco
ms el rendimiento.  Si por el contrario su objetivo es
exprimirlo
.I mucho
ms, debera estar utilizando la opcin
.B \-Cf
o
.B \-CF
(comentadas ms abajo), que activa
.B \-B
automticamente de todas maneras.
.TP
.B \-F
especifica que se debe utilizar la representacin de la tabla
.ul
rpida
(y elimina referencias a stdio).  Esta representacin es aproximadamente tan
rpida como la representacin completa de la tabla
.B (-f),
y para algunos conjuntos de patrones ser considerablemente ms
pequea (y para otros, mayor).  En general, si el conjunto de patrones
contiene "palabras clave" y una regla "identificador" atrpalo-todo,
como la del conjunto:
.nf

    "case"    return TOK_CASE;
    "switch"  return TOK_SWITCH;
    ...
    "default" return TOK_DEFAULT;
    [a-z]+    return TOK_ID;

.fi
entonces ser mejor que utilice la representacin de la tabla
completa.  Si slo est presente la regla "identificador" y utiliza
una tabla hash o algo parecido para detectar palabras clave, mejor
utilice
.B -F.
.IP
Esta opcin es equivalente a
.B \-CFr
(ver ms abajo).  Esta opcin no puede utilizarse con
.B \-+.
.TP
.B \-I
ordena a
.I flex
que genere un analizador
.I interactivo
Un analizador interactivo es uno que solo mira hacia delante
para decidir que token ha sido reconocido nicamente si debe hacerlo.
Resulta que mirando siempre un caracter extra hacia delante, incluso
si el analizador ya ha visto suficiente texto para eliminar la
ambigedad del token actual, se es un poco ms rpido que mirando
solamente cuando es necesario.  Pero los analizadores que siempre
miran hacia delante producen un comportamiento interactivo malsimo; por
ejemplo, cuando un usuario teclea una lnea nueva, esta no se reconoce
como un token de lnea nueva hasta que introduzca
.I otro
token, que a menudo significa introducir otra lnea completa.
.IP
Los analizadores de
.I flex
por defecto son
.I interactivos
a menos que use la opcin
.B \-Cf
o
.B \-CF
de compresin de tablas (ver ms abajo).  Esto es debido a que si est
buscando un rendimiento alto tendra que estar utilizando una de estas
opciones, as que si no lo ha hecho
.I flex
asume que prefiere cambiar un poco de rendimiento en tiempo de
ejecucin en beneficio de un comportamiento iteractivo intuitivo.
Fjese tambin que
.I no puede
utilizar
.B \-I
conjuntamente con
.B \-Cf
o
.B \-CF.
As, esta opcin no se necesita realmente; est activa por defecto
para todos esos casos en los que se permite.
.IP
Usted puede forzar al analizador que
.I no
sea interactivo usando
.B \-B
(ver ms arriba).
.TP
.B \-L
ordena a
.I flex
que no genere directivas
.B #line.
Sin esta opcin, 
.I flex
acribilla al analizador generado con directivas #line para que los
mensajes de error en las acciones estn localizadas correctamente
respecto al fichero original de
.I flex
(si los errores son debidos al cdigo en el fichero de entrada), o a
.B lex.yy.c
(si los errores son fallos de
.I flex
-- debera informar de este tipo de errores a la direccin de correo
dada ms abajo).
.TP
.B \-T
hace que
.I flex
se ejecute en modo de
.I traza.
Este generar un montn de mensajes en
.I stderr
relativos a la forma de la entrada y el autmata finito no-determinista o
determinista resultante.  Esta opcin generalmente es para usarla en
el mantenimiento de
.I flex.
.TP
.B \-V
imprime el nmero de la versin en
.I stdout
y sale.
.B \-\-version
es un sinnimo de
.B \-V.
.TP
.B \-7
ordena a
.I flex
que genere un analizador de 7-bits, es decir, uno que slo puede
reconocer caracteres de 7-bits en su entrada.  La ventaja de usar
.B \-7
es que las tablas del analizador pueden ser hasta la mitad del tamao
de aquellas generadas usando la opcin
.B \-8
(ver ms abajo).  La desventaja es que tales analizadores a menudo se
cuelgan o revientan si su entrada contiene caracteres de 8-bits.
.IP
Fjese, sin embargo, que a menos que genere su analizador utilizando
las opciones de compresin de tablas
.B \-Cf
o
.B \-CF,
el uso de
.B \-7
ahorrar solamente una pequea cantidad de espacio en la tabla, y har
su analizador considerablemente menos portable.
El comportamiento por defecto de
.I flex
es generar un analizador de 8-bits a menos que use
.B \-Cf
o
.B \-CF,
en cuyo caso
.I flex
por defecto genera analizadores de 7-bits a menos que su sistema
siempre est configurado para generar analizadores de 8-bits (a menudo
este ser el caso de los sistemas fuera de EEUU).  Puede decir si flex
gener un analizador de 7 u 8 bits inspeccionando el sumario de
banderas en la salida de
.B \-v
como se describi anteriormente.
.IP
Fjese que si usa
.B \-Cfe
o
.B \-CFe
(esas opciones de compresin de tablas, pero tambin el uso de clases
de equivalencia como se comentar ms abajo), flex genera an por
defecto un analizador de 8-bits, ya que normalmente con estas opciones
de compresin las tablas de 8-bits completas no son mucho ms caras
que las tablas de 7-bits.
.TP
.B \-8
ordena a
.I flex
que genere un analizador de 8-bits, es decir, uno que puede reconocer
caracteres de 8-bits.  Esta bandera slo es necesaria para
analizadores generados usando
.B \-Cf
o
.B \-CF,
ya que de otra manera flex por defecto genera un analizador de 8-bits
de todas formas.
.IP
Vea el comentario sobre
.B \-7
ms arriba a cerca del comportamiento por defecto de flex y la
discusin entre los analizadores de 7-bits y 8-bits.
.TP
.B \-+
especifica que quiere que flex genere un analizador como una clase de
C++.  Vea la seccin Generando Escners en C++ ms abajo para los
detalles.
.TP 
.B \-C[aefFmr]
controla el grado de compresin de la tabla y, ms generalmente,
el compromiso entre analizadores pequeos y analizadores rpidos.
.IP
.B \-Ca
("alinea") ordena a flex que negocie tablas ms grandes en el
analizador generado para un comportamiento ms rpido porque los
elementos de las tablas estn mejor alineados para el acceso a
memoria y computacin.  En algunas arquitecturas RISC, la bsqueda y
manipulacin de palabras largas es ms eficiente que con unidades ms
pequeas tales como palabras cortas.  Esta opcin puede doblar el
tamao de las tablas usadas en su analizador.
.IP
.B \-Ce
ordena a
.I flex
que construya
.I clases de equivalencia,
es decir, conjunto de caracteres
que tienen identicas propiedades lxicas (por ejemplo, si la nica
aparicin de dgitos en la entrada de
.I flex
es en la clase de caracteres
"[0-9]" entonces los dgitos '0', '1', ..., '9' se pondrn todos en la
misma clase de equivalencia).  Las clases de equivalencia normalmente
ofrecen notables reducciones en los tamaos de los ficheros finales de
tabla/objeto (tpicamente un factor de 2-5) y son juiciosamente
bastante baratos en cuanto al rendimiento (una localizacin en un
vector por caracter analizado).
.IP
.B \-Cf
especifica que se deben generar las tablas del analizador
.I completas
-
.I flex
no debera comprimir las tablas tomando ventaja de las funciones de
transicin similares para diferentes estados.
.IP
.B \-CF
especifica que debera usarse la representacin del analizador rpido
alternativo (descrito anteriormente en la bandera
.B \-F
)
Esta opcin no puede usarse con
.B \-+.
.IP
.B \-Cm
ordena a
.I flex
a que construya
.I clases de meta-equivalencias,
que son conjuntos de clases de equivalencia (o caracteres, si las
clases de equivalencia no se estn usando) que comunmente se usan de forma
conjunta.  Las clases de meta-equivalencias son a menudo un gran
ahorro cuando se usan tablas comprimidas, pero tienen un impacto
moderado en el rendimiento (uno o dos tests "if" y una localizacin en
un array por caracter analizado).
.IP
.B \-Cr
hace que el analizador generado
.I elimine
el uso de la librera de E/S estndar para la entrada.  En lugar de
llamar a
.B fread()
o
.B getc(),
el analizador utilizar la llamada al sistema
.B read(),
produciendo una ganancia en el rendimiento que vara de sistema en
sistema, pero en general probablemente es insignificante a menos que
tambin est usando
.B \-Cf
o
.B \-CF.
El uso de
.B \-Cr
puede producir un comportamiento extrao si, por ejemplo, lee de
.I yyin
usando stdio antes de llamar al analizador (porque el analizador
perder cualquier texto que sus lecturas anteriores dejaron en el
buffer de entrada de stdio).
.IP
.B \-Cr
no tiene efecto si usted define
.B YY_INPUT
(ver El Escner Generado ms arriba).
.IP
Con solamente
.B \-C
se especifica que las tablas del analizador deberan comprimirse
pero no debera utilizarse ni las clases de equivalencia ni las clases
de meta-equivalencias.
.IP
Las opciones
.B \-Cf
o
.B \-CF
y
.B \-Cm
no tienen sentido juntas - no hay oportunidad para las clases de
meta-equivalencias si la tabla no est siendo comprimida.  De otra
forma las opciones podran mezclarse lbremente, y son acumulativas.
.IP
La configuracin por defecto es
.B \-Cem,
que especifica que
.I flex
debera generar clases de equivalencia y clases de meta-equivalencias.
Esta configuracin provee el mayor grado de compresin.  Puede
llegarse a un compromiso entre analizadores de ejecucin ms rpida
con el coste de tablas mayores siendo generalmente verdadero lo siguiente:
.nf

    lo ms lento y pequeo
          -Cem
          -Cm
          -Ce
          -C
          -C{f,F}e
          -C{f,F}
          -C{f,F}a
    lo ms rpido y grande

.fi
Fjese que los analizadores con tablas ms pequeas normalmente se
generan y compilan de la forma ms rpida posible, as que durante el
desarrollo usted normalmente querr usar como viene por defecto,
compresin mxima.
.IP
.B \-Cfe
a menudo es un buen compromiso entre velocidad y tamao para la
produccin de analizadores.
.TP
.B \-osalida
ordena a flex que escriba el analizador al fichero
.B salida
en lugar de a
.B lex.yy.c.
Si combina
.B \-o
con la opcin
.B \-t,
entonces el analizador se escribe en
.I stdout
pero sus directivas
.B #line
(vea la opcin
.B \\-L
ms arriba) hacen referencia al fichero
.B salida.
.TP
.B \-Pprefijo
cambia el prefijo
.I "yy"
usado por defecto por
.I flex
para todas las variables visibles globalmente y nombres de funciones
para que sea
.I prefijo.
Por ejemplo,
.B \-Pfoo
cambia el nombre de
.B yytext
a
.B footext.
Este tambin cambia el nombre por defecto del fichero de salida de
.B lex.yy.c
a
.B lex.foo.c.
Aqu estn todos los nombres afectados:
.nf

    yy_create_buffer
    yy_delete_buffer
    yy_flex_debug
    yy_init_buffer
    yy_flush_buffer
    yy_load_buffer_state
    yy_switch_to_buffer
    yyin
    yyleng
    yylex
    yylineno
    yyout
    yyrestart
    yytext
    yywrap

.fi
(Si usted est utilizando un analizador en C++, entonces nicamente
.B yywrap
y
.B yyFlexLexer
se ven afectados.)
Dentro de su analizador, puede an hacer referencia a las variables
globales y funciones usando cualquier versin de su nombre; pero
externamente, estas tienen el nombre modificado.
.IP
Esta opcin le deja enlazar fcilmente mltiples programas
.I flex
conjuntamente en el mismo ejecutable.  Fjese, sin embargo, que usando
esta opcin tambin se renombra
.B yywrap(),
de manera que ahora
.I debe
o bien proveer su propia versin de la rutina (con el nombre
apropiado) para su analizador, o usar
.B %option noyywrap,
ya que enlazar con
.B \-lfl
no podr proveerle una por defecto.
.TP
.B \-Sfichero_esqueleto
ignora el fichero de esqueleteo por defecto con el que
.I flex
construye sus analizadores.  Usted probablemente nunca necesitar
utilizar esta opcin a menos que este haciendo mantenimiento o
un desarrollo de
.I flex.
.PP
.I flex
tambin ofrece un mecanismo para controlar las opciones dentro de la
propia especificacin del analizador, en vez de a partir de la lnea
de comando.  Esto se hace incluyendo las directivas
.B %option
en la primera seccin de la especificacin del analizador.  Usted
puede especificar varias opciones con una sola directiva
.B %option,
y varias directivas en la primera seccin de su fichero de entrada de
flex.
.PP
La mayora de las opciones vienen dadas simplemente como nombres,
opcionalmente precedidos por la palabra "no" (sin intervenir un
espacio) para negar su significado.  Las banderas de flex o su negacin
son equivalentes a un nmero:
.nf

    7bit            opcin -7
    8bit            opcin -8
    align           opcin -Ca
    backup          opcin -b
    batch           opcin -B
    c++             opcin -+

    caseful o
    case-sensitive  opuesto de -i (por defecto)

    case-insensitive o
    caseless        opcin -i

    debug           opcin -d
    default         opuesto de la opcin -s
    ecs             opcin -Ce
    fast            opcin -F
    full            opcin -f
    interactive     opcin -I
    lex-compat      opcin -l
    meta-ecs        opcin -Cm
    perf-report     opcin -p
    read            opcin -Cr
    stdout          opcin -t
    verbose         opcin -v
    warn            opuesto de la opcin -w
                    (use "%option nowarn" para -w)

    array           equivalente a "%array"
    pointer         equivalente a "%pointer" (por defecto)

.fi
Algunas directivas
.B %option
ofrecen propiedades que de otra manera no estn disponibles:
.TP
.B always-interactive
ordena a flex que genere un analizador que siempre considere su
entrada como "interactiva".  Normalmente, sobre cada fichero de
entrada nuevo el analizador llama a
.B isatty()
como intento para determinar si la entrada del analizador es
interactiva y por lo tanto debera leer un caracter a la vez.  Cuando
esta opcin se utilice, sin embargo, entonces no se hace tal llamada.
.TP
.B main
ordena a flex que facilite un programa
.B main()
por defecto para el analizador, que simplemente llame a
.B yylex().
Esta opcin implica
.B noyywrap
(ver ms abajo).
.TP
.B never-interactive
ordena a flex que genere un analizador que nunca considere su
entrada como "interactiva" (de nuevo, no se hace ninguna llamada a
.B isatty()).
Esta es la opuesta a
.B always-interactive.
.TP
.B stack
activa el uso de pilas de condiciones de arranque (ver Condiciones de
Arranque ms arriba).
.TP
.B stdinit
si se establece (es decir,
.B %option stdinit)
inicializa
.I yyin
e
.I yyout
a
.I stdin
y
.I stdout,
en lugar del que viene por defecto que es
.I nil.
Algunos pogramas de
.I lex
existentes dependen de este comportamiento, incluso si no sigue el ANSI
C, que no requiere que
.I stdin
y
.I stdout
sean constantes en tiempo de compilacin.
.TP
.B yylineno
ordena a
.I flex
a generar un analizador que mantenga el nmero de la lnea actual
leda desde su entrada en la variable global
.B yylineno.
Esta opcin viene implcita con
.B %option lex-compat.
.TP
.B yywrap
si no se establece (es decir,
.B %option noyywrap),
hace que el analizador no llame a
.B yywrap()
hasta el fin-de-fichero, pero simplemente asume que no hay ms
ficheros que analizar (hasta que el usuario haga apuntar
.I yyin
a un nuevo fichero y llame a
.B yylex()
otra vez).
.PP
.I flex
analiza las acciones de sus reglas para determinar si utiliza las
propiedades 
.B REJECT
o
.B yymore()
Las opciones
.B reject
e
.B yymore
estn disponibles para ignorar sus decisiones siempre que use las
opciones, o bien estableciendolas (p.ej.,
.B %option reject)
para indicar que la propiedad se utiliza realmente, o desactivndolas
para indicar que no es utilizada
(p.ej.,
.B %option noyymore).
.PP
Tres opciones toman valores delimitados por cadenas, separadas por '=':
.nf

    %option outfile="ABC"

.fi
es equivalente a
.B -oABC,
y
.nf

    %option prefix="XYZ"

.fi
es equivalente a
.B -PXYZ.
Finalmente,
.nf

    %option yyclass="foo"

.fi
slo se aplica cuando se genera un analizador en C++ (opcin
.B \-+).
Este informa a
.I flex
que ha derivado a
.B foo
como una subclase de
.B yyFlexLexer,
as que
.I flex
pondr sus acciones en la funcin miembro
.B foo::yylex()
en lugar de
.B yyFlexLexer::yylex().
Este tambin genera una funcin miembro
.B yyFlexLexer::yylex()
que emite un error en tiempo de ejecucin (invocando a
.B yyFlexLexer::LexerError())
si es llamada.
Ver Generando Escners en C++, ms abajo, para informacin adicional.
.PP
Estn disponibles un nmero de opciones para los puristas de lint que
desean suprimir la aparicin de rutinas no necesarias en el analizador
generado.  Cada una de la siguientes, si se desactivan (p.ej.,
.B %option nounput
), hace que la rutina correspondiente no aparezca en el analizador
generado:
.nf

    input, unput
    yy_push_state, yy_pop_state, yy_top_state
    yy_scan_buffer, yy_scan_bytes, yy_scan_string

.fi
(aunque
.B yy_push_state()
y sus amigas no aparecern de todas manera a menos que use
.B %option stack).
.SH CONSIDERACIONES DE RENDIMIENTO
El principal objetivo de diseo de
.I flex
es que genere analizadores de alto rendimiento.  Este ha sido
optimizado para comportarse bien con conjuntos grandes de reglas.
Aparte de los efectos sobre la velocidad del analizador con las
opciones de compresin de tablas
.B \-C
anteriormente introducidas, hay un nmero de opciones/acciones que
degradan el rendimiento.  Estas son, desde la ms costosa a la menos:
.nf

    REJECT
    %option yylineno
    contexto posterior arbitrario

    conjunto de patrones que requieren retroceso
    %array
    %option interactive
    %option always-interactive

    '^' operador de comienzo de lnea
    yymore()

.fi
siendo las tres primeras bastante costosas y las dos ltimas bastante
econmicas.  Fjese tambin que
.B unput()
se implementa como una llamada de rutina que potencialmente hace
bastante trabajo, mientras que
.B yyless()
es una macro bastante econmica; as que si est devolviendo algn
texto excedente que ha analizado, use
.B yyless().
.PP
.B REJECT
debera evitarse a cualquier precio cuando el rendimiento es
importante.  Esta es una opcin particularmente cara.
.PP
Es lioso deshacerse del retroceso y a menudo podra ser una cantidad
de trabajo enorme para un analizador complicado.  En principio, uno
comienza utilizando la bandera
.B \-b 
para generar un archivo
.I lex.backup.
Por ejemplo, sobre la entrada
.nf

    %%
    foo        return TOK_KEYWORD;
    foobar     return TOK_KEYWORD;

.fi
el fichero tiene el siguiente aspecto:
.nf

    El estado #6 es no-aceptar -
     nmeros de lnea asociados a la regla:
           2       3
     fin de transiciones: [ o ]
     transiciones de bloqueo: fin de archivo (EOF) [ \\001-n  p-\\177 ]

    El estado #8 es no-aceptar -
     nmeros de lnea asociados a la regla:
           3
     fin de transiciones: [ a ]
     transiciones de bloqueo: fin de archivo (EOF) [ \\001-`  b-\\177 ]

    El estado #9 es no-aceptar -
     nmeros de lnea asociados a la regla:
           3
     fin de transiciones: [ r ]
     transiciones de bloqueo: fin de archivo (EOF) [ \\001-q  s-\\177 ]

    Las tablas comprimidas siempre implican un retroceso.

.fi
Las primeras lneas nos dicen que hay un estado del analizador en el
que se puede hacer una transicin con una 'o' pero no sobre cualquier
otro caracter, y que en ese estado el texto recientemente analizado no
empareja con ninguna regla.  El estado ocurre cuando se intenta
emparejar las reglas encontradas en las lneas 2 y 3 en el fichero de
entrada.  Si el analizador est en ese estado y entoces lee cualquier
cosa que no sea una 'o', tendr que retroceder para encontrar una
regla que empareje.  Con un poco de anlisis uno puede ver que
este debe ser el estado en el que se est cuando se ha visto "fo".
Cuando haya ocurrido, si se ve cualquier cosa que no sea una 'o', el
analizador tendr que retroceder para simplemente emparejar la 'f'
(por la regla por defecto).
.PP
El comentario que tiene que ver con el Estado #8 indica que hay un
problema cuando se analiza "foob".  En efecto, con cualquier caracter
que no sea una 'a', el analizador tendr que retroceder para aceptar
"foo".  De forma similar, el comentario para el Estado #9 tiene que
ver cuando se ha analizado "fooba" y no le sigue una 'r'.
.PP
El comentario final nos recuerda que no mecere la pena todo el trabajo
para eliminar el retroceso de las reglas a menos que estemos usando
.B \-Cf
o
.B \-CF,
y que no hay ninguna mejora del rendimiento hacindolo con
analizadores comprimidos.
.PP
La manera de quitar los retrocesos es aadiendo reglas de "error":
.nf

    %%
    foo         return TOK_KEYWORD;
    foobar      return TOK_KEYWORD;

    fooba       |
    foob        |
    fo          {
                /* falsa alarma, realmente no es una palabra clave */
                return TOK_ID;
                }

.fi
.PP
La eliminacin de retroceso en una lista de palabras clave tambin
puede hacerse utilizando una regla "atrpalo-todo":
.nf

    %%
    foo         return TOK_KEYWORD;
    foobar      return TOK_KEYWORD;

    [a-z]+      return TOK_ID;

.fi
Normalmente esta es la mejor solucin cuando sea adecuada.
.PP
Los mensajes sobre retrocesos tienden a aparecer en cascada.
Con un conjunto complicado de reglas no es poco comn obtener cientos
de mensajes.  Si uno puede descifrarlos, sin embargo, a menudo slo
hay que tomar una docena de reglas o algo as para eliminar los
retrocesos (ya que es fcil cometer una equivocacin y tener una regla de
error que reconozca un token vlido.  Una posible caracterstica
futura de 
.I flex
ser aadir reglas automticamente para eliminar el retroceso).
.PP
Es importante tener en cuenta que se obtienen los beneficios de
eliminar el retroceso slo si elimina
.I cada
instancia del retroceso.  Dejar solamente una significa que no ha
ganado absolutamente nada.
.PP
El contexto posterior
.I variable
(donde la parte delantera y posterior no tienen una longitud fija)
supone casi la misma prdida de rendimiento que
.B REJECT
(es decir, substanciales).  As que cuando sea posible una regla como
esta:
.nf

    %%
    raton|rata/(gato|perro)   correr();

.fi
es mejor escribirla as:
.nf

    %%
    raton/gato|perro          correr();
    rata/gato|perro           correr();

.fi
o as
.nf

    %%
    raton|rata/gato           correr();
    raton|rata/perro          correr();

.fi
Fjese que aqu la accin especial '|'
.I no
ofrece ningn ahorro, y puede incluso hacer las cosas peor (ver
Deficiencias / Errores ms abajo).
.LP
Otro rea donde el usuario puede incrementar el rendimiento del
analizador (y una que es ms fcil de implementar) surge del hecho que
cuanto ms tarde se empareje un token, ms rpido ir el analizador.
Esto es debido a que con tokens grandes el procesamiento de la mayora
de los caracteres de entrada tiene lugar en el (corto) bucle de
anlisis ms interno, y no tiene que ir tan a menudo a hacer el
trabajo de ms para constituir el entorno del analizador (p.ej.,
.B yytext)
para la accin.  Recuerde el analizador para los comentarios en C:
.nf

    %x comentario
    %%
            int num_linea = 1;

    "/*"         BEGIN(comentario);

    <comentario>[^*\\n]*
    <comentario>"*"+[^*/\\n]*
    <comentario>\\n             ++num_linea;
    <comentario>"*"+"/"        BEGIN(INITIAL);

.fi
Esto podra acelerarse escribindolo como:
.nf

    %x comentario
    %%
            int num_linea = 1;

    "/*"         BEGIN(comentario);

    <comentario>[^*\\n]*
    <comentario>[^*\\n]*\\n      ++num_linea;
    <comentario>"*"+[^*/\\n]*
    <comentario>"*"+[^*/\\n]*\\n ++num_linea;
    <comentario>"*"+"/"        BEGIN(INITIAL);

.fi
Ahora en lugar de que cada lnea nueva requiera el procesamiento de
otra regla, el reconocimiento de las lneas nuevas se "distribuye"
sobre las otras reglas para mantener el texto reconocido tan largo
como sea posible.  Fjese que el
.I aadir
reglas
.I no
ralentiza el analizador!  La velocidad del analizador es independiente
del nmero de reglas o (dadas las consideraciones dadas al inicio
de esta seccin) cun complicadas sean las reglas respecto a
operadores tales como '*' y '|'.
.PP
Un ejemplo final sobre la aceleracin de un analizador: suponga que
quiere analizar un fichero que contiene identificadores y
palabras clave, una por lnea y sin ningn caracter extrao, y
reconocer todas las palabras clave.  Una primera aproximacin natural
es:
.nf

    %%
    asm      |
    auto     |
    break    |
    ... etc ...
    volatile |
    while    /* es una palabra clave */

    .|\\n     /* no es una palabra clave */

.fi
Para eliminar el retroceso, introduzca una regla atrpalo-todo:
.nf

    %%
    asm      |
    auto     |
    break    |
    ... etc ...
    volatile |
    while    /* es una palabra clave */

    [a-z]+   |
    .|\\n     /* no es una palabra clave */

.fi
Ahora, si se garantiza que hay exctamente una palabra por lnea,
entonces podemos reducir el nmero total de emparejamientos por la
mitad mezclando el reconocimiento de lneas nuevas con las de los
otros tokens:
.nf

    %%
    asm\\n    |
    auto\\n   |
    break\\n  |
    ... etc ...
    volatile\\n |
    while\\n  /* es una palabra clave */

    [a-z]+\\n |
    .|\\n     /* no es una palabra clave */

.fi
Uno tiene que ser cuidadoso aqu, ya que hemos reintroducido retroceso
en el analizador.  En particular, aunque
.I nosotros
sepamos que ah nunca habrn otros caracteres en el flujo de entrada
que no sean letras o lneas nuevas,
.I flex
no puede figurarse eso, y planear la posible necesidad de
retroceder cuando haya analizado un token como "auto" y el prximo
caracter sea algo distinto a una lnea nueva o una letra.  Previamente
este podra entonces emparejar la regla "auto" y estar todo hecho, pero
ahora este no tiene una regla "auto", solamente una regla "auto\\n".
Para eliminar la posibilidad de retroceso, podramos o bien duplicar
todas las reglas pero sin lnea nueva al final, o, ya que nunca
esperamos encontrar tal entrada y por lo tanto ni cmo es clasificada,
podemos introducir una regla atrpalo-todo ms, esta que no incluye
una lnea nueva:
.nf

    %%
    asm\\n    |
    auto\\n   |
    break\\n  |
    ... etc ...
    volatile\\n |
    while\\n  /* es una palabra clave */

    [a-z]+\\n |
    [a-z]+   |
    .|\\n     /* no es una palabra clave */

.fi
Compilado con
.B \-Cf,
esto es casi tan rpido como lo que uno puede obtener de un analizador
de
.I flex
para este problema en particular.
.PP
Una nota final:
.I flex
es lento cuando empareja NUL's, particularmente cuando un token
contiene mltiples NUL's.
Es mejor escribir reglas que emparejen
.I cortas
cantidades de texto si se anticipa que el texto incluir NUL's a
menudo.
.PP
Otra nota final en relacin con el rendimiento: tal y como se mencion
en la seccin Cmo se Reconoce la Entrada, el reajuste dinmico de
.B yytext
para acomodar tokens enormes es un proceso lento porque ahora requiere
que el token (inmenso) sea reanalizado desde el principio.  De esta
manera si el rendimiento es vital, debera intentar emparejar
"grandes" cantidades de texto pero no "inmensas" cantidades, donde el
punto medio est en torno a los 8K caracteres/token.
.SH GENERANDO ESCNERES EN C++
.I flex
ofrece dos maneras distintas de generar analizadores para usar con
C++.  La primera manera es simplemente compilar un analizador generado
por
.I flex
usando un compilador de C++ en lugar de un compilador de C.  No
debera encontrarse ante ningn error de compilacin (por favor
informe de cualquier error que encuentre a la direccin de correo
electrnico dada en la seccin Autores ms abajo).  Puede entonces
usar cdigo C++ en sus acciones de las reglas en lugar de cdigo C.
Fjese que la fuente de entrada por defecto para su analizador permanece
como
.I yyin,
y la repeticin por defecto se hace an a
.I yyout.
Ambos permanecen como variables
.I FILE *
y no como 
.I flujos
de C++.
.PP
Tambin puede utilizar
.I flex
para generar un analizador como una clase de C++, utilizando la opcin
.B \-+
(o, equivalentemente,
.B %option c++),
que se especifica automticamente si el nombre del ejecutable de flex
finaliza con un '+', tal como
.I flex++.
Cuando se usa esta opcix, flex establece por defecto la generacin
del analizador al fichero
.B lex.yy.cc
en vez de
.B lex.yy.c.
El analizador generado incluye el fichero de cabecera
.I FlexLexer.h,
que define el interfaz con las dos clases de C++.
.PP
La primera clase,
.B FlexLexer,
ofrece una clase base abstracta definiendo la interfaz a la clase del
analizador general.  Este provee las siguientes funciones miembro:
.TP
.B const char* YYText()
retorna el texto del token reconocido ms recientemente, el equivalente
a
.B yytext.
.TP
.B int YYLeng()
retorna la longitud del token reconocido ms recientemente, el
equivalente a
.B yyleng.
.TP
.B int lineno() const
retorna el nmero de lnea de entrada actual
(ver
.B %option yylineno),
o
.B 1
si no se us
.B %option yylineno.
.TP
.B void set_debug( int flag )
activa la bandera de depuracin para el analizador, equivalente a
la asignacin de
.B yy_flex_debug
(ver la seccin Opciones ms arriba).  Fjese que debe construir el
analizador utilizando
.B %option debug
para incluir informacin de depuracin en este.
.TP
.B int debug() const
retorna el estado actual de la bandera de depuracin.
.PP
Tambin se proveen funciones miembro equivalentes a
.B yy_switch_to_buffer(),
.B yy_create_buffer()
(aunque el primer argumento es un puntero a objeto
.B istream*
y no un
.B FILE*),
.B yy_flush_buffer(),
.B yy_delete_buffer(),
y
.B yyrestart()
(de nuevo, el primer argumento es un puntero a objeto
.B istream*
).
.PP
La segunda clase definida en
.I FlexLexer.h
es
.B yyFlexLexer,
que se deriva de
.B FlexLexer.
Esta define las siguientes funciones miembro adicionales:
.TP
.B
yyFlexLexer( istream* arg_yyin = 0, ostream* arg_yyout = 0 )
construye un objeto
.B yyFlexLexer
usando los flujos dados para la entrada y salida.  Si no se
especifica, los flujos se establecen por defecto a
.B cin
y
.B cout,
respectivamente.
.TP
.B virtual int yylex()
hace el mismo papel que
.B yylex()
en los analizadores de flex ordinarios: analiza el flujo de entrada,
consumiendo tokens, hasta que la accin de una regla retorne un
valor.  Si usted deriva una subclase
.B S
a partir de
.B yyFlexLexer
y quiere acceder a las funciones y variables miembro de
.B S
dentro de
.B yylex(),
entonces necesita utilizar
.B %option yyclass="S"
para informar a
.I flex
que estar utilizando esa subclase en lugar de
.B yyFlexLexer.
Es este caso, en vez de generar
.B yyFlexLexer::yylex(),
.I flex
genera
.B S::yylex()
(y tambin genera un substituto
.B yyFlexLexer::yylex()
que llama a
.B yyFlexLexer::LexerError()
si se invoca).
.TP
.B
virtual void switch_streams(istream* new_in = 0,
.B
ostream* new_out = 0)
reasigna
.B yyin
a
.B new_in
(si no es nulo)
e
.B yyout
a
.B new_out
(idem), borrando el buffer de entrada anterior si se reasigna
.B yyin.
.TP
.B
int yylex( istream* new_in, ostream* new_out = 0 )
primero conmuta el flujo de entrada via
.B switch_streams( new_in, new_out )
y entonces retorna el valor de
.B yylex().
.PP
Adems,
.B yyFlexLexer
define las siguientes funciones virtuales protegidas que puede
redefinir en clases derivadas para adaptar el analizador:
.TP
.B
virtual int LexerInput( char* buf, int max_size )
lee hasta
.B max_size
caracteres en
.B buf
y devuelve el nmero de caracteres ledos.  Para indicar el
fin-de-la-entrada, devuelve 0 caracteres.  Fjese que los analizadores
"interactivos" (ver las banderas
.B \-B
y
.B \-I
) definen la macro
.B YY_INTERACTIVE.
Si usted redefine
.B LexerInput()
y necesita tomar acciones distintas dependiendo de si el analizador
est analizando una fuente de entrada interactivo o no, puede
comprobar la presencia de este nombre mediante
.B #ifdef.
.TP
.B
virtual void LexerOutput( const char* buf, int size )
escribe a la salida
.B size
caracteres desde el buffer
.B buf,
que, mientras termine en NUL, puede contener tambin NUL's "internos"
si las reglas del analizador pueden emparejar texto con NUL's dentro
de este.
.TP
.B
virtual void LexerError( const char* msg )
informa con un mensaje de error fatal.  La versin por defecto de esta
funcin escribe el mensaje al flujo
.B cerr
y finaliza.
.PP
Fjese que un objeto
.B yyFlexLexer
contiene su estado de anlisis
.I completo.
As puede utilizar tales objetos para crear analizadore reentrantes.
Puede hacer varias instancias de la misma clase
.B yyFlexLexer,
y puede combinar varias clases de analizadores en C++ conjuntamente en
el mismo programa usando la opcin
.B \-P
comentada anteriormente.
.PP
Finalmente, note que la caracterstica
.B %array
no est disponible en clases de analizadores en C++; debe utilizar
.B %pointer
(por defecto).
.PP
Aqu hay un ejemplo de un analizador en C++ simple:
.nf

    // Un ejemplo del uso de la clase analizador en C++ de flex.

    %{
    int mylineno = 0;
    %}

    string  \\"[^\\n"]+\\"

    ws      [ \\t]+

    alpha   [A-Za-z]
    dig     [0-9]
    name    ({alpha}|{dig}|\\$)({alpha}|{dig}|[_.\\-/$])*
    num1    [-+]?{dig}+\\.?([eE][-+]?{dig}+)?
    num2    [-+]?{dig}*\\.{dig}+([eE][-+]?{dig}+)?
    number  {num1}|{num2}

    %%

    {ws}    /* evita los espacios en blanco y tabuladores */

    "/*"    {
            int c;

            while((c = yyinput()) != 0)
                {
                if(c == '\\n')
                    ++mylineno;

                else if(c == '*')
                    {
                    if((c = yyinput()) == '/')
                        break;
                    else
                        unput(c);
                    }
                }
            }

    {number}  cout << "nmero " << YYText() << '\\n';

    \\n        mylineno++;

    {name}    cout << "nombre " << YYText() << '\\n';

    {string}  cout << "cadena " << YYText() << '\\n';

    %%

    int main( int /* argc */, char** /* argv */ )
        {
        FlexLexer* lexer = new yyFlexLexer;
        while(lexer->yylex() != 0)
            ;
        return 0;
        }
.fi
Si desea crear varias (diferentes) clases analizadoras, use la bandera
.B \-P
(o la opcin
.B prefix=
) para renombrar cada
.B yyFlexLexer
a algn otro
.B xxFlexLexer.
Entonces puede incluir
.B <FlexLexer.h>
en los otros ficheros fuente una vez por clase analizadora, primero
renombrando 
.B yyFlexLexer
como se presenta a continuacin:
.nf

    #undef yyFlexLexer
    #define yyFlexLexer xxFlexLexer
    #include <FlexLexer.h>

    #undef yyFlexLexer
    #define yyFlexLexer zzFlexLexer
    #include <FlexLexer.h>

.fi
si, por ejemplo, usted utiliz
.B %option prefix="xx"
para uno de sus analizadores y
.B %option prefix="zz"
para el otro.
.PP
IMPORTANTE: la forma actual de la clase analizadora es
.I experimental
y podra cambiar considerablemente entre versiones principales.
.SH INCOMPATIBILIDADES CON LEX Y POSIX
.I flex
es una reescritura de la herramienta
.I lex
del Unix de AT&T
(aunque las dos implementaciones no comparten ningn cdigo),
con algunas extensiones e incompatibilidades, de las que ambas
conciernen a aquellos que desean escribir analizadores aceptables por
cualquier implementacin.  Flex sigue completamente la especificacin
POSIX de
.I lex,
excepto que cuando se utiliza
.B %pointer
(por defecto), una llamada a
.B unput()
destruye el contenido de
.B yytext,
que va en contra de la especificacin POSIX.
.PP
En esta seccin comentaremos todas las reas conocidas de
incompatibilidades entre flex, lex de AT&T, y la especificacin POSIX.
.PP
La opcin
.B \-l
de
.I flex
activa la mxima compatibilidad con la implementacin original de
.I lex
de AT&T, con el coste de una mayor prdida de rendimiento en el
analizador generado.  Indicamos ms abajo qu incompatibilidades
pueden superarse usando la opcin
.B \-l.
.PP
.I flex
es totalmente compatible con
.I lex
con las siguientes excepciones:
.IP -
La variable interna del analizador de
.I lex
sin documentar
.B yylineno
no se ofrece a menos que se use
.B \-l
o
.B %option yylineno.
.IP
.B yylineno
debera gestionarse por buffer, en lugar de por analizador (simple
variable global).
.IP
.B yylineno
no es parte de la especificacin POSIX.
.IP -
La rutina
.B input()
no es redefinible, aunque podra invocarse para leer los caracteres
que siguen a continuacin de lo que haya sido reconocido por una
regla.  Si
.B input()
se encuentra con un fin-de-fichero se realiza el procesamiento de
.B yywrap()
normal.
.B input()
retorna un fin-de-fichero ``real'' como
.I EOF.
.IP
La entrada en su lugar se controla definiendo la macro
.B YY_INPUT.
.IP
La restriccin de
.I flex
de que
.B input()
no puede redefinirse va de acuerdo a la especificacin POSIX, que
simplemente no especifica ninguna manera de controlar la entrada del
analizador que no sea haciendo una asignacin inicial a
.I yyin.
.IP -
La rutina
.B unput()
no es redefinible.  Esta restriccin va de acuerdo a POSIX.
.IP -
Los analizadores de
.I flex
no son tan reentrantes como los analizadores de
.I lex.
En particular, si tiene un analizador interactivo y un gestor de
interrupcin con long-jumps fuera del analizador, y el analizador a
continuacin se invoca de nuevo, podra obtener el siguiente mensaje:
.nf

    fatal flex scanner internal error--end of buffer missed

.fi
Para volver al analizador, primero utilice
.nf

    yyrestart( yyin );

.fi
Vea que esta llamada eliminar cualquier entrada en el buffer;
normalmente esto no es un problema con un analizador interactivo.
.IP
Dese cuenta tambin de que las clases analizadoras en C++
.I son
reentrantes, as que si usar C++ es una opcin para usted, debera
utilizarla.  Vea "Generando Escners en C++" ms arriba para los
detalles.
.IP -
.B output()
no se provee.
La salida desde la macro
.B ECHO
se hace al puntero de fichero
.I yyout
(por defecto a
.I stdout).
.IP
.B output()
no es parte de la especificacin POSIX.
.IP -
.I lex
no acepta condiciones de arranque exclusivas (%x), aunque estn en la
especificacin POSIX.
.IP -
Cuando se expanden las definiciones,
.I flex
las encierra entre parntesis.
Con lex, lo siguiente:
.nf

    NOMBRE    [A-Z][A-Z0-9]*
    %%
    foo{NOMBRE}?      printf( "Lo encontr\\n" );
    %%

.fi
no reconocer la cadena "foo" porque cuando la macro se expanda la
regla es equivalente a "foo[A-Z][A-Z0-9]*?" y la precedencia es tal
que el '?' se asocia con
"[A-Z0-9]*".  Con
.I flex,
la regla se expandir a
"foo([A-Z][A-Z0-9]*)?" y as la cadena "foo" se reconocer.
.IP
Fjese que si la definicin comienza con
.B ^
o finaliza con
.B $
entonces
.I no
se expande con parntesis, para permitir que estos operadores
aparezcan en las definiciones sin perder su significado especial.
Pero los operadores
.B <s>, /,
y
.B <<EOF>>
no pueden utilizarse en una definicin de
.I flex.
.IP
El uso de
.B \-l
produce en el comportamiendo de
.I lex
el no poner parntesis alrededor de la definicin.
.IP
La especificacin de POSIX dice que la definicin debe ser encerrada
entre parntesis.
.IP -
Algunas implementaciones de
.I lex
permiten que la accin de una regla comience en una lnea separada, si
el patrn de la regla tiene espacios en blanco al final:
.nf

    %%
    foo|bar<espacio aqu>
      { foobar_action(); }

.fi
.I flex
no dispone de esta propiedad.
.IP -
La opcin
.B %r
de
.I lex
(generar un analizador Ratfor) no se ofrece.  No es parte de la
especificacin de POSIX.
.IP -
Despus de una llamada a
.B unput(),
el contenido de
.I yytext
est indefinido hasta que se reconozca el prximo token, a menos que
el analizador se haya construido usando
.B %array.
Este no es el caso de
.I lex
o la especificacin de POSIX.  La opcin
.B \-l
elimina esta incompatibilidad.
.IP -
La precedencia del operador
.B {}
(rango numrico) es diferente.
.I lex
interpreta "abc{1,3}" como "empareja uno, dos, o tres apariciones de
 'abc'", mientras que
.I flex
lo interpreta como "empareja 'ab' seguida de una, dos o tres
apariciones de 'c'".  Lo ltimo va de acuerdo con la especificacin de
POSIX.
.IP -
La precedencia del operador
.B ^
es diferente.
.I lex
interpreta "^foo|bar" como "empareja bien 'foo' al principio de una
lnea, o 'bar' en cualquier lugar", mientras que
.I flex
lo interpreta como "empareja 'foo' o 'bar' si vienen al principio de
una lnea".  Lo ltimo va de acuerdo con la especificacin de POSIX.
.IP -
Las declaraciones especiales del tamao de las tablas tal como
.B %a
que reconoce
.I lex
no se requieren en los analizadores de
.I flex;
.I flex
los ignora.
.IP -
El identificador
.bd
FLEX_SCANNER
se #define de manera que los analizadores podran escribirse para
ser procesados con
.I flex
o con
.I lex.
Los analizadores tambin incluyen
.B YY_FLEX_MAJOR_VERSION
y
.B YY_FLEX_MINOR_VERSION
indicando qu versin de
.I flex
gener el analizador
(por ejemplo, para la versin 2.5, estas definiciones sern 2 y 5
respectivamente).
.PP
Las siguientes propiedades de
.I flex
no se incluyen en
.I lex
o la especificacin POSIX:
.nf

    analizadores en C++
    %option
    mbitos de condiciones de arranque
    pilas de condiciones de arranque
    analizadores interactivos/no-interactivos
    yy_scan_string() y sus amigas
    yyterminate()
    yy_set_interactive()
    yy_set_bol()
    YY_AT_BOL()
    <<EOF>>
    <*>
    YY_DECL
    YY_START
    YY_USER_ACTION
    YY_USER_INIT
    directivas #line
    %{}'s alrededor de acciones
    varias acciones en una lnea

.fi
ms casi todas las banderas de flex.
La ltima propiedad en la lista se refiere al hecho de que con
.I flex
puede poner varias acciones en la misma lnea, sepradas con punto y
coma, mientras que con
.I lex,
lo siguiente
.nf

    foo    handle_foo(); ++num_foos_seen;

.fi
se trunca (sorprendentemente) a
.nf

    foo    handle_foo();

.fi
.I flex
no trunca la accin.  Las acciones que no se encierran en llaves
simplemente se terminan al final de la lnea.
.SH DIAGNSTICOS
.PP
.I aviso, la regla no se puede aplicar
indica que la regla dada
no puede emparejarse porque sigue a otras reglas que siempre
emparejarn el mismo texto que el de esta.  Por ejemplo, en el
siguiente ejemplo "foo" no puede emparejarse porque viene despus de
una regla "atrpalo-todo" para identificadores:
.nf

    [a-z]+    obtuvo_identificador();
    foo       obtuvo_foo();

.fi
El uso de
.B REJECT
en un analizador suprime este aviso.
.PP
.I aviso,
.I se ha especificado la opcin 
.B -s
.I pero se puede aplicar la regla por defecto
significa que es posible (tal vez nicamente en una condicin de
arranque en particular) que la regla por defecto (emparejar cualquier
caracter simple) sea la nica que emparejar una entrada particular.
Ya que se indic
.B \-s,
presumiblemente esto no es lo que se pretenda.
.PP
.I definicin no definida {reject_used_but_not_detected}
o
.I definicin no definida {yymore_used_but_not_detected} -
Estos errores pueden suceder en tiempo de compilacin.  Indican que el
analizador usa
.B REJECT
o
.B yymore()
pero que
.I flex
fall en darse cuenta del hecho, queriendo decir que
.I flex
analiz las dos primeras secciones buscando apariciones de estas
acciones y fall en encontrar alguna, pero que de algn modo se le han
colado (por medio de un archivo #include, por ejemplo).  Use
.B %option reject
o
.B %option yymore
para indicar a flex que realmente usa esta funcionalidad.
.PP
.I flex scanner jammed -
un analizador compilado con
.B \-s
ha encontrado una cadena de entrada que no fue reconocida por niguna
de sus reglas.  Este error puede suceder tambin debido a problemas
internos.
.PP
.I token too large, exceeds YYLMAX -
su analizador usa
.B %array
y una de sus reglas reconoci una cadena ms grande que la constante
.B YYLMAX
(8K bytes por defecto).  Usted puede incrementar el valor haciendo un
#define
.B YYLMAX
en la seccin de definiciones de su entrada de
.I flex.
.PP
.I el analizador requiere la opcin -8 para
.I poder usar el carcter 'x' -
La especificacin de su analizador incluye el reconocimiento del
caracter de 8-bits
.I 'x'
y no ha especificado la bandera \-8, y su analizador por defecto est
a 7-bits porque ha usado las opciones
.B \-Cf
o
.B \-CF
de compresin de tablas.  Vea el comentario de la bandera
.B \-7
para los detalles.
.PP
.I flex scanner push-back overflow -
usted utiliz
.B unput()
para devolver tanto texto que el buffer del analizador no pudo
mantener el texto devuelto y el token actual en
.B yytext.
Idealmente el analizador debera ajustar dinmicamente el buffer en
este caso, pero actualmente no lo hace.
.PP
.I
input buffer overflow, can't enlarge buffer because scanner uses REJECT -
el analizador estaba intentando reconocer un token extremadamente
largo y necesit expandir el buffer de entrada.  Esto no funciona con
analizadores que usan
.B
REJECT.
.PP
.I
fatal flex scanner internal error--end of buffer missed -
Esto puede suceder en un analizador que se reintroduce despus de que
un long-jump haya saltado fuera (o sobre) el registro de activacin del
analizador.  Antes de reintroducir el analizador, use:
.nf

    yyrestart( yyin );

.fi
o, como se coment ms arriba, cambie y use el analizador como clase
de C++.
.PP
.I too many start conditions in <> construct! -
ha listado ms condiciones de arranque en una construccin <> que las
que existen (as que tuvo que haber listado al menos una de ellas dos
veces).
.SH FICHEROS
.TP
.B \-lfl
librera con la que los analizadores deben enlazarse.
.TP
.I lex.yy.c
analizador generado (llamado
.I lexyy.c
en algunos sistemas).
.TP
.I lex.yy.cc
clase generada en C++ con el analizador, cuando se utiliza
.B -+.
.TP
.I <FlexLexer.h>
fichero de cabecera definiendo la clase base del analizador en C++,
.B FlexLexer,
y su clase derivada,
.B yyFlexLexer.
.TP
.I flex.skl
esqueleto del analizador.  Este fichero se utiliza nicamente cuando
se construye flex, no cuando flex se ejecuta.
.TP
.I lex.backup
informacin de los retrocesos para la bandera
.B \-b
(llamada
.I lex.bck
en algunos sistemas).
.SH DEFICIENCIAS / ERRORES
.PP
Algunos patrones de contexto posterior no pueden reconocerse
correctamente y generan mensajes de aviso ("contexto posterior
peligroso").  Estos son patrones donde el final de la primera parte
de la regla reconoce el comienzo de la segunda parte, tal como
"zx*/xy*", donde el 'x*' reconoce la 'x' al comienzo del contexto
posterior. (Fjese que el borrador de POSIX establece que el texto
reconocido por tales patrones no est definido.)
.PP
Para algunas reglas de contexto posterior, partes que son de hecho de
longitud fija no se reconocen como tales, resultando en la prdida de
rendimiento mencionada anteriormente.  En particular, las partes que
usan '|' o {n} (tales como "foo{3}") siempre se consideran de longitud
variable.
.PP
La combinacin de contexto posterior con la accin especial '|' puede
producir que el contexto posterior
.I fijo
se convierta en contexto posterior
.I variable
que es ms caro.  Por ejemplo, en lo que viene a continuacin:
.nf

    %%
    abc      |
    xyz/def

.fi
.PP
El uso de
.B unput()
invalida yytext e yyleng, a menos que se use la directiva
.B %array
o la opcin
.B \-l.
.PP
La concordancia de patrones de NUL's es substancialmente ms lento
que el reconocimiento de otros caracteres.
.PP
El ajuste dinmico del buffer de entrada es lento, ya que conlleva el
reanlisis de todo el texto reconocido hasta entonces por el
(generalmente enorme) token actual.
.PP
Debido al uso simultneo de buffers de entrada y lecturas por
adelantado, no puede entremezclar llamadas a rutinas de <stdio.h>,
tales como, por ejemplo,
.B getchar(),
con reglas de
.I flex
y esperar que funcione.  Llame a
.B input()
en su lugar.
.PP
La totalidad de las entradas de la tabla listada por la bandera
.B \-v
excluye el nmero de entradas en la tabla necesarias para determinar
qu regla ha sido emparejada.  El nmero de entradas es igual al nmero
de estados del DFA si el analizador no usa 
.B REJECT,
y algo mayor que el nmero de estados si se usa.
.PP
.B REJECT
no puede usarse con las opciones
.B \-f
o
.B \-F.
.PP
El algoritmo interno de
.I flex
necesita documentacin.
.SH VER TAMBIN
.PP
lex(1), yacc(1), sed(1), awk(1).
.PP
John Levine, Tony Mason, and Doug Brown,
.I Lex & Yacc,
O'Reilly and Associates.  Est seguro de obtener la 2 edicin.
.PP
M. E. Lesk and E. Schmidt,
.I LEX \- Lexical Analyzer Generator
.PP
Alfred Aho, Ravi Sethi and Jeffrey Ullman,
.I Compilers: Principles, Techniques and Tools,
Addison-Wesley (1986)
(Edicin en castellano:
.I Compiladores: Principios, Tcnicas y Herramientas,
Addison-Wesley Iberoamericana, S.A. (1990))  Describe las tcnicas de
concordancia de patrones usadas por
.I flex
(autmata finito determinista).
.SH AUTOR
Vern Paxson, con la ayuda de muchas ideas e inspiracin de
Van Jacobson.  Versin original por Jef Poskanzer.  La representacin
de tablas rpidas es una implementacin parcial de un diseo hecho por
Van Jacobson.  La implementacin fue hecha por Kevin Gong y Vern Paxson.
.PP
Agradecimientos a los muchos
.I flex
beta-testers, feedbackers, y contribuidores, especialmente a Francois Pinard,
Casey Leedom,
Robert Abramovitz,
Stan Adermann, Terry Allen, David Barker-Plummer, John Basrai,
Neal Becker, Nelson H.F. Beebe, benson@odi.com,
Karl Berry, Peter A. Bigot, Simon Blanchard,
Keith Bostic, Frederic Brehm, Ian Brockbank, Kin Cho, Nick Christopher,
Brian Clapper, J.T. Conklin,
Jason Coughlin, Bill Cox, Nick Cropper, Dave Curtis, Scott David
Daniels, Chris G. Demetriou, Theo Deraadt,
Mike Donahue, Chuck Doucette, Tom Epperly, Leo Eskin,
Chris Faylor, Chris Flatters, Jon Forrest, Jeffrey Friedl,
Joe Gayda, Kaveh R. Ghazi, Wolfgang Glunz,
Eric Goldman, Christopher M. Gould, Ulrich Grepel, Peer Griebel,
Jan Hajic, Charles Hemphill, NORO Hideo,
Jarkko Hietaniemi, Scott Hofmann,
Jeff Honig, Dana Hudes, Eric Hughes, John Interrante,
Ceriel Jacobs, Michal Jaegermann, Sakari Jalovaara, Jeffrey R. Jones,
Henry Juengst, Klaus Kaempf, Jonathan I. Kamens, Terrence O Kane,
Amir Katz, ken@ken.hilco.com, Kevin B. Kenny,
Steve Kirsch, Winfried Koenig, Marq Kole, Ronald Lamprecht,
Greg Lee, Rohan Lenard, Craig Leres, John Levine, Steve Liddle,
David Loffredo, Mike Long,
Mohamed el Lozy, Brian Madsen, Malte, Joe Marshall,
Bengt Martensson, Chris Metcalf,
Luke Mewburn, Jim Meyering, R. Alexander Milowski, Erik Naggum,
G.T. Nicol, Landon Noll, James Nordby, Marc Nozell,
Richard Ohnemus, Karsten Pahnke,
Sven Panne, Roland Pesch, Walter Pelissero, Gaumond
Pierre, Esmond Pitt, Jef Poskanzer, Joe Rahmeh, Jarmo Raiha,
Frederic Raimbault, Pat Rankin, Rick Richardson,
Kevin Rodgers, Kai Uwe Rommel, Jim Roskind, Alberto Santini,
Andreas Scherer, Darrell Schiebel, Raf Schietekat,
Doug Schmidt, Philippe Schnoebelen, Andreas Schwab,
Larry Schwimmer, Alex Siegel, Eckehard Stolz, Jan-Erik Strvmquist,
Mike Stump, Paul Stuart, Dave Tallman, Ian Lance Taylor,
Chris Thewalt, Richard M. Timoney, Jodi Tsai,
Paul Tuinenga, Gary Weik, Frank Whaley, Gerhard Wilhelms, Kent Williams, Ken
Yap, Ron Zellar, Nathan Zelle, David Zuhn,
y aquellos cuyos nombres han cado bajo mis escasas dotes de
archivador de correo pero cuyas contribuciones son apreciadas todas
por igual.

.PP
Agradecimientos a Keith Bostic, Jon Forrest, Noah Friedman,
John Gilmore, Craig Leres, John Levine, Bob Mulcahy, G.T.
Nicol, Francois Pinard, Rich Salz, y a Richard Stallman por la ayuda con
diversos quebraderos de cabeza con la distribucin.
.PP
Agradecimientos a Esmond Pitt y Earle Horton por el soporte de
caracteres de 8-bits; a Benson Margulies y a Fred Burke por el soporte
de C++; a Kent Williams y a Tom Epperly por el soporte de la clase de
C++; a Ove Ewerlid por el soporte de NUL's; y a Eric Hughes por el
soporte de mltiples buffers.
.PP
Este trabajo fue hecho principalmente cuando yo estaba con el Grupo de
Sistemas de Tiempo Real en el Lawrence Berkeley Laboratory en
Berkeley, CA.  Muchas gracias a todos all por el apoyo que recib.
.PP
Enviar comentarios a vern@ee.lbl.gov.
.PP
Sobre esta traduccin enviar comentarios a Adrin Prez
Jorge (alu1415@csi.ull.es).
